theory question_14_1

imports Main

begin
typedecl entity
typedecl event

consts
  Male :: "entity ⇒ bool"
  Man :: "entity ⇒ bool"
  Standing :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  BrownClothing :: "entity ⇒ bool"
  StreetSide :: "entity ⇒ bool"
  ThumbOut :: "entity ⇒ bool"
  BigBagOnBack :: "entity ⇒ bool"

(* Explanation 1: A male is a man. *)
axiomatization where
  explanation_1: "∀x. Male x ⟶ Man x"

theorem hypothesis:
  (* Premise: A male with brown clothing standing on the side of the street with his thumb out with a big bag on his back. *)
  assumes asm: "Male x ∧ BrownClothing x ∧ StreetSide x ∧ ThumbOut x ∧ BigBagOnBack x ∧ Standing e ∧ Agent e x"
  (* Hypothesis: a man is standing *)
  shows "∃x e. Man x ∧ Standing e ∧ Agent e x"
proof -
  from asm have "Male x" by blast
  then have "Man x" using explanation_1 by blast
  then show ?thesis using asm by blast
qed

end
