theory question_24_6

imports Main

begin
typedecl entity
typedecl event
consts
  Cute :: "entity ⇒ bool"
  Couple :: "entity ⇒ bool"
  Club :: "entity ⇒ bool"
  At :: "entity ⇒ entity ⇒ bool"

(* Explanation 1: ∀x y z. Cute(x) ∧ Couple(y) ∧ Club(z) ∧ At(x, z) ⟶ At(x, z) *)
axiomatization where
  explanation_1: "∀x y z. Cute x ∧ Couple y ∧ Club z ∧ At x z ⟶ At x z"

theorem hypothesis:
  (* Premise: ∀x y. Cute(x) ∧ Couple(y) ∧ Club(y) *)
  assumes asm: "Cute x ∧ Couple y ∧ Club y"
  (* Hypothesis: ∃x y e. Couple(x) ∧ Club(y) ∧ At(x, y) *)
  shows "∃x y e. Couple x ∧ Club y ∧ At x y"
proof -
  from asm have "Cute x ∧ Couple y ∧ Club y ∧ At x y" by blast
  then have "At x y" using explanation_1 by blast
  then show ?thesis using asm by blast
qed

end
