theory question_39_9

imports Main

begin
typedecl entity
typedecl event

consts
  Boys :: "entity ⇒ bool"
  ParticipatingInGame :: "event ⇒ bool"
  PlayingBasketball :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Uniform :: "entity ⇒ (entity ⇒ bool) ⇒ bool"
  PlayBasketball :: "event ⇒ bool"

(* Explanation 1: Boys actively participating in the basketball game are playing basketball. *)
axiomatization where
  explanation_1: "∃x e. Boys x ∧ ParticipatingInGame e ∧ PlayingBasketball e ∧ Agent e x"

theorem hypothesis:
  (* Premise: Two boys in green and white uniforms play basketball with two boys in blue and white uniforms. *)
  assumes asm: "Boys x ∧ Boys y ∧ Uniform x GreenWhite ∧ Uniform y BlueWhite ∧ PlayBasketball e ∧ Agent e x ∧ Agent e y"
  (* Hypothesis: Boys are playing basketball. *)
  shows "∃x e. Boys x ∧ PlayingBasketball e ∧ Agent e x"
proof -
  from asm have "Boys x ∧ PlayBasketball e ∧ Agent e x" by blast
  then show ?thesis using asm by blast
qed

end
