theory question_60_10
imports Main

begin
typedecl entity
typedecl event

consts
  Boy :: "entity ⇒ bool"
  KarateForm :: "entity ⇒ bool"
  Uniform :: "entity ⇒ bool"
  Poses :: "event ⇒ bool"
  Implies :: "event ⇒ bool"
  Showcasing :: "event ⇒ bool"
  Posing :: "event ⇒ bool"
  Includes :: "event ⇒ bool"
  Display :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Patient :: "event ⇒ entity ⇒ bool"

(* Explanation 1: When a boy poses in karate form and uniform, it directly implies that he is showcasing his uniform. *)
axiomatization where
  explanation_1: "∀x y z e1 e2. Boy x ∧ KarateForm y ∧ Uniform z ∧ Poses e1 ∧ Agent e1 x ∧ Patient e1 y ∧ Patient e1 z ∧ Implies e2 ∧ Agent e2 x ∧ Patient e2 z ∧ Showcasing e2"

(* Explanation 2: The act of posing in karate form by a boy naturally includes the display of the uniform. *)
axiomatization where
  explanation_2: "∀x y z e. Boy x ∧ KarateForm y ∧ Uniform z ∧ Posing e ∧ Agent e x ∧ Patient e y ∧ Patient e z ∧ Includes e ∧ Display e"

theorem hypothesis:
  (* Premise: A boy poses in karate form and uniform. *)
  assumes asm: "Boy x ∧ KarateForm y ∧ Uniform z ∧ Poses e ∧ Agent e x ∧ Patient e y ∧ Patient e z"
  (* Hypothesis: a boy shows "his uniform" *)
  shows "∃x y e. Boy x ∧ Uniform y ∧ Showcasing e ∧ Possessor e x y"
proof -
  from asm have "Boy x ∧ KarateForm y ∧ Uniform z ∧ Poses e ∧ Agent e x ∧ Patient e y ∧ Patient e z" by blast
  then have "Boy x ∧ Uniform z ∧ Showcasing e" using explanation_1 by blast
  then show ?thesis using asm by blast
qed

end
