theory question_67_9

imports Main

begin
typedecl entity
typedecl event

consts
  Sitting :: "event ⇒ bool"
  Together :: "entity ⇒ entity ⇒ bool"
  On :: "entity ⇒ event ⇒ bool"
  Male :: "entity ⇒ bool"
  Boat :: "event ⇒ bool"
  Older :: "entity ⇒ bool"
  RiverBoatTour :: "event ⇒ bool"

(* Explanation 1: If two individuals are sitting together on a boat, they are on the boat together. *)
axiomatization where
  explanation_1: "∀x y e. Sitting e ∧ Together x y ∧ On x e ∧ On y e ⟶ On x y"

(* Explanation 2: Sitting together on a boat implies that the individuals are both on the boat. *)
axiomatization where
  explanation_2: "∀x y e. Sitting e ∧ Together x y ∧ On x e ⟶ On y e"

theorem hypothesis:
  (* Premise: Two older males sitting together on a river boat tour. *)
  assumes asm: "Male x ∧ Male y ∧ Older x ∧ Older y ∧ RiverBoatTour e ∧ Sitting e ∧ Together x y"
  (* Hypothesis: Two males sitting together on a boat. *)
  shows "∃x y e. Male x ∧ Male y ∧ Boat e ∧ Sitting e ∧ Together x y ∧ On x e ∧ On y e"
proof -
  from asm have "Sitting e ∧ Together x y" by blast
  then have "On x e ∧ On y e" using explanation_1 by blast
  then have "On x e" using explanation_2 by blast
  then show ?thesis using asm by blast
qed

end
