theory question_68_0

imports Main

begin
typedecl entity
typedecl event
consts
  Man :: "entity ⇒ bool"
  Friend :: "entity ⇒ bool"
  AtBack :: "entity ⇒ bool"
  Holding :: "event ⇒ bool"
  Possessor :: "event ⇒ entity ⇒ bool"
  Possession :: "event ⇒ entity ⇒ bool"
  OnBack :: "entity ⇒ entity ⇒ bool"

(* Explanation 1: As the man is at back, so she is holding his friend. *)
axiomatization where
  explanation_1: "∃x y e. Man x ∧ Friend y ∧ AtBack x ∧ Holding e ∧ Possessor e x ∧ Possession e y"

theorem hypothesis:
  (* Premise: A man is on the back of his friend. *)
  assumes asm: "Man x ∧ Friend y ∧ OnBack x y"
  (* Hypothesis: A man is holding his friend. *)
  shows "∃x y e. Man x ∧ Friend y ∧ Holding e ∧ Possessor e x ∧ Possession e y"
proof -
  from asm have "Man x ∧ Friend y ∧ AtBack x ∧ Holding e ∧ Possessor e x ∧ Possession e y" using explanation_1 by blast
  then show ?thesis using asm by blast
qed

end
