theory question_77_6
imports Main

begin
typedecl entity
typedecl event

consts
  GoldenColoredDog :: "entity ⇒ bool"
  LightColoredFur :: "entity ⇒ bool"
  GoldenColoredFur :: "entity ⇒ bool"
  Dog :: "entity ⇒ bool"
  LightColored :: "entity ⇒ bool"
  AlertEyes :: "entity ⇒ bool"
  Holds :: "entity ⇒ entity ⇒ bool"
  BrightlyColoredTennisBall :: "entity ⇒ bool"

(* Explanation 1: A golden-colored dog typically has light-colored fur. *)
axiomatization where
  explanation_1: "∀x. GoldenColoredDog x ⟶ LightColoredFur x"

(* Explanation 2: Golden-colored fur on a dog is indicative of the dog being light colored. *)
axiomatization where
  explanation_2: "∀x. GoldenColoredFur x ∧ Dog x ⟶ LightColored x"

theorem hypothesis:
  (* Premise: A golden-colored dog, with his eyes alert, holds a brightly colored tennis ball in his mouth. *)
  assumes asm: "GoldenColoredDog x ∧ AlertEyes x ∧ Holds x BrightlyColoredTennisBall"
  (* Hypothesis: The dog is light colored. *)
  shows "∃x. Dog x ∧ LightColored x"
proof -
  from asm have "GoldenColoredDog x" by blast
  then have "LightColoredFur x" using explanation_1 by blast
  then have "LightColored x" if "GoldenColoredFur x" for x using explanation_2 by blast
  then show ?thesis using asm by blast
qed

end
