theory question_84_0

imports Main

begin
typedecl entity
typedecl event

consts
  Boy :: "entity ⇒ bool"
  Indian :: "entity ⇒ bool"
  Shorts :: "entity ⇒ bool"
  Play :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Patient :: "event ⇒ entity ⇒ bool"
  With :: "event ⇒ entity ⇒ bool"

(* Explanation 1: There are three boys *)
axiomatization where
  explanation_1: "∃x y z. Boy x ∧ Boy y ∧ Boy z ∧ (x ≠ y) ∧ (x ≠ z) ∧ (y ≠ z)"

theorem hypothesis:
  (* Premise: Three Indian boys in shorts play with one another. *)
  assumes asm: "Boy x ∧ Boy y ∧ Boy z ∧ Indian x ∧ Indian y ∧ Indian z ∧ Shorts x ∧ Shorts y ∧ Shorts z ∧ Play e ∧ Agent e x ∧ Patient e y ∧ With e z ∧  x ≠ y  ∧  x ≠ z  ∧  y ≠ z "
  (* Hypothesis: Three boys. *)
  shows "∃x y z. Boy x ∧ Boy y ∧ Boy z ∧  x ≠ y  ∧  x ≠ z  ∧  y ≠ z "
proof -
  from asm have "∃x y z. Boy x ∧ Boy y ∧ Boy z ∧ (x ≠ y) ∧ (x ≠ z) ∧ (y ≠ z)" using explanation_1 by blast
  then show ?thesis using asm by blast
qed

end
