theory question_91_1

imports Main

begin
typedecl entity
typedecl event

consts
  Children :: "entity ⇒ bool"
  Playing :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Outside :: "event ⇒ bool"

(* Explanation 1: Children are typically engaged in playing activities. *)
axiomatization where
  explanation_1: "∀x e. Children x ⟶ Playing e ∧ Agent e x"

theorem hypothesis:
  (* Premise: Several children playing outside *)
  assumes asm: "Children x ∧ Playing e ∧ Outside e ∧ Agent e x"
  (* Hypothesis: There are children playing. *)
  shows "∃x e. Children x ∧ Playing e ∧ Agent e x"
proof -
  from asm have "Children x ∧ Playing e ∧ Agent e x" by blast
  then show ?thesis using explanation_1 by blast
qed

end
