theory question_93_0

imports Main

begin
typedecl entity
typedecl event
consts
  Lambs :: "entity ⇒ bool"
  Animals :: "entity ⇒ bool"
  Woman :: "entity ⇒ bool"
  Chasing :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Patient :: "event ⇒ entity ⇒ bool"

(* Explanation 1: ∀x y z e. Lambs(x) ∧ Animals(y) ∧ Woman(z) ∧ Chasing(e) ∧ Agent(e, z) ∧ Patient(e, x) ∧ Patient(e, y) *)
axiomatization where
  explanation_1: "∀x y z e. Lambs x ∧ Animals y ∧ Woman z ∧ Chasing e ∧ Agent e z ∧ Patient e x ∧ Patient e y"

theorem hypothesis:
  (* Premise: Old woman chasing away two lambs with a broom. *)
  assumes asm: "Lambs x ∧ Animals y ∧ Woman z ∧ Chasing e ∧ Agent e z ∧ Patient e x ∧ Patient e y"
  (* Hypothesis: ∃x y. Woman(x) ∧ Animals(y) *)
  shows "∃x y. Woman x ∧ Animals y"
proof -
  from asm have "Lambs x ∧ Animals y ∧ Woman z" by blast
  then show ?thesis using `Woman z` `Animals y` by blast
qed

end
