theory question_10_10

imports Main

begin

typedecl entity
typedecl event

consts
  Plants :: "entity ⇒ bool"
  Roots :: "event ⇒ bool"
  Grow :: "event ⇒ bool"
  Help :: "event ⇒ entity ⇒ bool"

(* Explanation 1: Plants grow with the help of roots. *)
axiomatization where
  explanation_1: "∀x e. Plants x ∧ Roots e ⟶ Grow e ∧ Help e x"

theorem hypothesis:
  assumes asm: "Plants x ∧ Roots e"
  (* Hypothesis: Plants grow with the help of roots. *)
  shows "∃e. Grow e ∧ Help e x"
proof -
  from asm have "Plants x ∧ Roots e" by simp
  then obtain e where e: "Grow e ∧ Help e x" using explanation_1 by blast
  then show ?thesis using e by blast
qed

end
