theory question_75_3
imports Main

begin

typedecl entity
typedecl event

consts
  ExtremeHeat :: "entity ⇒ bool"
  Pressure :: "entity ⇒ bool"
  Rock :: "entity ⇒ bool"
  Marble :: "entity ⇒ bool"
  Change :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Patient :: "event ⇒ entity ⇒ bool"
  MetamorphicRock :: "entity ⇒ bool"

(* Explanation 1: Extreme heat and pressure change rock specifically into marble, which is a form of metamorphic rock. *)
axiomatization where
  explanation_1: "∀x y z e. ExtremeHeat x ∧ Pressure y ∧ Rock z ∧ Marble e ∧ Change e ∧ Agent e x ∧ Agent e y ∧ Patient e z ⟶ MetamorphicRock e"

(* Explanation 2: Marble is a form of metamorphic rock, and it is the specific result of the change process induced by extreme heat and pressure on rock. *)
axiomatization where
  explanation_2: "∀x. Marble x ⟶ MetamorphicRock x"

theorem hypothesis:
  assumes asm: "ExtremeHeat x ∧ Pressure y ∧ Rock z"
  (* Hypothesis: Extreme heat and pressure change rock into marble. *)
  shows "∃x y z e. ExtremeHeat x ∧ Pressure y ∧ Rock z ∧ Marble e ∧ Change e ∧ Agent e x ∧ Agent e y ∧ Patient e z ∧ Patient e e"
proof -
  from asm have "ExtremeHeat x ∧ Pressure y ∧ Rock z" by simp
  then obtain e where e: "Marble e ∧ Change e ∧ Agent e x ∧ Agent e y ∧ Patient e z" using explanation_1 by blast
  then have "MetamorphicRock e" using explanation_2 by blast
  have conclusion: "Marble e ∧ Change e ∧ Agent e x ∧ Agent e y ∧ Patient e z" using e by simp
  show ?thesis using asm conclusion `MetamorphicRock e` by blast
qed

end
