theory question_18_0

imports Main

begin
typedecl entity
typedecl event

consts
  Competition :: "entity ⇒ bool"
  JavelinCompetition :: "entity ⇒ bool"
  TakePlace :: "entity ⇒ entity ⇒ bool"

(* Explanation 1: There must be a competition for a Javelin competition to take place. *)
axiomatization where
  explanation_1: "∀x y. Competition x ∧ JavelinCompetition y ⟶ TakePlace y x"

theorem hypothesis:
  (* Premise: Javelin competition *)
  assumes asm: "JavelinCompetition x"
  (* Hypothesis: There is a competition. *)
  shows "∃x. Competition x"
proof -
  have "∃y. Competition y ∧ JavelinCompetition x" using explanation_1 asm by blast
  then show ?thesis by blast
qed

end
