theory question_19_0

imports Main

begin
typedecl entity
typedecl event

consts
  Woman :: "entity ⇒ bool"
  Purple :: "entity ⇒ bool"
  Sweater :: "entity ⇒ bool"
  OddLook :: "entity ⇒ bool"
  OnFace :: "entity ⇒ entity ⇒ bool"
  In :: "entity ⇒ entity ⇒ bool"
  Gives :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Patient :: "event ⇒ entity ⇒ bool"
  Result :: "event ⇒ entity ⇒ bool"

(* Explanation 1: The color purple gives the woman the look on her face. *)
axiomatization where
  explanation_1: "∀x y z e. Woman x ∧ Purple y ∧ Look z ∧ OnFace z x ∧ Gives e ∧ Agent e y ∧ Patient e x ∧ Result e z"

theorem hypothesis:
  (* Premise: A woman in a purple sweater has an odd look on her face. *)
  assumes asm: "Woman x ∧ Purple y ∧ Sweater y ∧ OddLook z ∧ OnFace z x ∧ In x y"
  (* Hypothesis: A woman in a purple sweater has an odd look on her face. *)
  shows "∃x y z. Woman x ∧ Purple y ∧ Sweater y ∧ OddLook z ∧ OnFace z x ∧ In x y"
proof -
  show ?thesis using asm by blast
qed

end
