theory question_32_0

imports Main

begin
typedecl entity
consts
  Man :: "entity ⇒ bool"
  Pants :: "entity ⇒ bool"
  Shirt :: "entity ⇒ bool"
  Wearing :: "entity ⇒ entity ⇒ entity ⇒ bool"
  LimeGreen :: "entity ⇒ entity ⇒ bool"
  Sign :: "entity ⇒ bool"
  Working :: "entity ⇒ entity ⇒ bool"

(* Explanation 1: The lime green is simply more detail to describe the pants and shirt the man is wearing. *)
axiomatization where
  explanation_1: "∀x y z. Man x ∧ Pants y ∧ Shirt z ∧ Wearing x y z ⟶ LimeGreen y z"

theorem hypothesis:
  (* Premise: A man wearing lime green pants and shirt working on a sign. *)
  assumes asm: "Man x ∧ Pants y ∧ Shirt z ∧ LimeGreen y z ∧ Wearing x y z ∧ Sign e ∧ Working e x"
  (* Hypothesis: A man wearing pants and shirt working on a sign. *)
  shows "∃x y z e. Man x ∧ Pants y ∧ Shirt z ∧ Wearing x y z ∧ Sign e ∧ Working e x"
proof -
  from asm have "Man x ∧ Pants y ∧ Shirt z ∧ Wearing x y z" by blast
  then show ?thesis using asm by blast
qed

end
