theory question_36_7
imports Main

begin
typedecl entity
typedecl event

consts
  BusyCityStreet :: "entity ⇒ bool"
  Street :: "entity ⇒ bool"
  People :: "entity ⇒ bool"
  Has :: "entity ⇒ entity ⇒ bool"
  ALotOf :: "entity ⇒ bool"
  Winter :: "entity ⇒ bool"
  Walking :: "entity ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Down :: "event ⇒ entity ⇒ bool"
  In :: "event ⇒ entity ⇒ bool"

(* Explanation 1: A busy city street is a street that has a lot of people. *)
axiomatization where
  explanation_1: "∀x y. BusyCityStreet x ⟶ (Street x ∧ (∃y. People y ∧ Has x y ∧ ALotOf y))"

theorem hypothesis:
  (* Premise: People walking down a busy city street in the winter. *)
  assumes asm: "People x ∧ BusyCityStreet y ∧ Winter z ∧ Walking x ∧ Agent e x ∧ Down e y ∧ In e z"
  (* Hypothesis: The street has a lot of people. *)
  shows "∃x y. Street x ∧ People y ∧ Has x y ∧ ALotOf y"
proof -
  from asm have "BusyCityStreet y" by blast
  then have "Street y ∧ (∃y. People y ∧ Has y y ∧ ALotOf y)" using explanation_1 by blast
  then show ?thesis using asm by blast
qed

end
