theory question_45_5

imports Main

begin
typedecl entity
typedecl event

consts
  Woman :: "entity ⇒ bool"
  Runs :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Outdoors :: "entity ⇒ bool"
  Person :: "entity ⇒ bool"
  BlackClothing :: "entity ⇒ bool"
  Street :: "entity ⇒ bool"
  Barefoot :: "entity ⇒ bool"
  People :: "entity ⇒ bool"
  Bicycles :: "entity ⇒ bool"
  FemaleRunner :: "entity ⇒ bool"
  Down :: "event ⇒ entity ⇒ bool"
  NextTo :: "entity ⇒ entity ⇒ bool"

(* Explanation 1: When a woman runs, she is outdoors. *)
axiomatization where
  explanation_1: "∀x e. Woman x ∧ Runs e ∧ Agent e x ⟶ Outdoors x"

(* Explanation 2: A woman is a person. *)
axiomatization where
  explanation_2: "∀x. Woman x ⟶ Person x"

theorem hypothesis:
  (* Premise: A woman in black clothing runs down the street barefoot next to two people on bicycles and a female runner. *)
  assumes asm: "Woman x ∧ BlackClothing x ∧ Street y ∧ Barefoot x ∧ People z ∧ Bicycles z ∧ FemaleRunner z ∧ Runs e ∧ Agent e x ∧ Down e y ∧ NextTo x z"
  (* Hypothesis: The woman is outdoors. *)
  shows "∃x. Woman x ∧ Outdoors x"
proof -
  from asm have "Woman x ∧ Runs e ∧ Agent e x" by blast
  then have "Outdoors x" using explanation_1 by blast
  then show ?thesis using `Woman x` `Outdoors x` by blast
qed

end
