theory question_61_0

imports Main

begin
typedecl entity
typedecl event

consts
  Woman :: "entity ⇒ bool"
  Seafood :: "entity ⇒ bool"
  Food :: "entity ⇒ bool"
  Eating :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Patient :: "event ⇒ entity ⇒ bool"
  Sunglasses :: "entity ⇒ bool"
  PoutingFace :: "event ⇒ bool"

(* Explanation 1: Seafood is a form a food that the woman is eating. *)
axiomatization where
  explanation_1: "∀x y e. Woman x ∧ Seafood y ∧ Food y ∧ Eating e ∧ Agent e x ∧ Patient e y"

theorem hypothesis:
  (* Premise: A woman in sunglasses making a pouting face while eating seafood. *)
  assumes asm: "Woman x ∧ Sunglasses z ∧ Seafood y ∧ PoutingFace e1 ∧ Eating e2 ∧ Agent e1 x ∧ Agent e2 x ∧ Patient e2 y"
  (* Hypothesis: A woman is eating. *)
  shows "∃x e. Woman x ∧ Eating e ∧ Agent e x"
proof -
  from asm have "Woman x ∧ Eating e2 ∧ Agent e2 x" by blast
  then show ?thesis using asm by blast
qed

end
