theory question_68_2

imports Main

begin
typedecl entity
typedecl event

consts
  Man :: "entity ⇒ bool"
  Friend :: "entity ⇒ bool"
  OnBack :: "entity ⇒ entity ⇒ bool"
  Holding :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Patient :: "event ⇒ entity ⇒ bool"

(* Explanation 1: If a man is on the back of his friend, he is holding his friend. *)
axiomatization where
  explanation_1: "∀x y e. Man x ∧ Friend y ∧ OnBack x y ⟶ (Holding e ∧ Agent e x ∧ Patient e y)"

theorem hypothesis:
  (* Premise: A man is on the back of his friend. *)
  assumes asm: "Man x ∧ Friend y ∧ OnBack x y"
  (* Hypothesis: A man is holding his friend. *)
  shows "∃x y e. Man x ∧ Friend y ∧ Holding e ∧ Agent e x ∧ Patient e y"
proof -
  from asm have "Man x ∧ Friend y ∧ OnBack x y" by blast
  then have "Holding e ∧ Agent e x ∧ Patient e y" using explanation_1 by blast
  then show ?thesis using asm by blast
qed

end
