theory question_90_0

imports Main

begin
typedecl entity
typedecl event

consts
  Workers :: "entity ⇒ bool"
  Grass :: "entity ⇒ bool"
  Pulling :: "event ⇒ bool"
  BentOver :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Patient :: "event ⇒ entity ⇒ bool"
  Three :: "entity ⇒ bool"

(* Explanation 1: Workers are pulling grass while they bent over. *)
axiomatization where
  explanation_1: "∀x y e1 e2. Workers x ∧ Grass y ∧ Pulling e1 ∧ Agent e1 x ∧ Patient e1 y ∧ BentOver e2 ∧ Agent e2 x"
  

theorem hypothesis:
  (* Premise: Three workers bent over pulling grass. *)
  assumes asm: "Workers x ∧ Three x ∧ Grass y ∧ BentOver e1 ∧ Agent e1 x ∧ Pulling e2 ∧ Agent e2 x ∧ Patient e2 y"
  (* Hypothesis: Three workers bent over. *)
  shows "∃x e. Workers x ∧ Three x ∧ BentOver e ∧ Agent e x"
proof -
  from asm have "Workers x ∧ Three x ∧ BentOver e1 ∧ Agent e1 x" by blast
  then show ?thesis by blast
qed

end
