theory question_94_3
imports Main

begin
typedecl entity
typedecl event

consts
  LittleBoy :: "entity ⇒ bool"
  Boy :: "entity ⇒ bool"
  Person :: "entity ⇒ bool"
  Bathroom :: "entity ⇒ bool"
  Building :: "entity ⇒ bool"
  In :: "entity ⇒ entity ⇒ bool"
  Inside :: "entity ⇒ entity ⇒ bool"
  Bathrobe :: "entity ⇒ bool"
  Bench :: "entity ⇒ bool"
  Shower :: "entity ⇒ bool"
  Sits :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  On :: "event ⇒ entity ⇒ bool"
  Near :: "event ⇒ entity ⇒ bool"

(* Explanation 1: A little boy is a boy. *)
axiomatization where
  explanation_1: "∀x. LittleBoy x ⟶ Boy x"

(* Explanation 2: If a person is in a bathroom, the bathroom is inside a building and thus the person is inside the building. *)
axiomatization where
  explanation_2: "∀x y z. Person x ∧ Bathroom y ∧ Building z ∧ In x y ⟶ (Inside y z ⟶ Inside x z)"

theorem hypothesis:
  (* Premise: A little boy in a bathrobe sits on a bench near the shower in a bathroom. *)
  assumes asm: "LittleBoy x ∧ Bathrobe x ∧ Bench y ∧ Shower z ∧ Bathroom z ∧ Sits e ∧ Agent e x ∧ On e y ∧ Near e z"
  (* Hypothesis: The boy is inside of the building. *)
  shows "∃x y. Boy x ∧ Building y ∧ Inside x y"
proof -
  from asm have "LittleBoy x ∧ Bathroom z" by blast
  then have "Boy x" using explanation_1 by blast
  from this have "Person x ∧ Bathroom z" by blast
  then have "Inside x z" using explanation_2 by blast
  then show ?thesis using `Boy x` `Inside x z` by blast
qed

end
