theory question_96_2
imports Main

begin
typedecl entity
typedecl event

consts
  Children :: "entity ⇒ bool"
  Adults :: "entity ⇒ bool"
  People :: "entity ⇒ bool"
  Swim :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  GroupOfPeople :: "entity ⇒ bool"
  Swimming :: "event ⇒ bool"
  Pool :: "entity ⇒ bool"
  Large :: "entity ⇒ bool"
  RedStaircase :: "entity ⇒ bool"
  In :: "event ⇒ entity ⇒ bool"

(* Explanation 1: Both children and adults are people. *)
axiomatization where
  explanation_1: "∀x y. Children x ∧ Adults y ⟶ People x ∧ People y"

(* Explanation 2: When children and adults swim together, they form a group of people swimming. *)
axiomatization where
  explanation_2: "∀x y e. Children x ∧ Adults y ∧ Swim e ∧ Agent e x ∧ Agent e y ⟶ (∃z. GroupOfPeople z ∧ Swimming z)"

theorem hypothesis:
  (* Premise: Children and adults swim in large pool with red staircase. *)
  assumes asm: "Children x ∧ Adults y ∧ Pool z ∧ Large z ∧ RedStaircase z ∧ Swim e ∧ Agent e x ∧ Agent e y ∧ In e z"
  (* Hypothesis: A group of people are swimming. *)
  shows "∃x e. GroupOfPeople x ∧ Swimming e ∧ Agent e x"
proof -
  from asm have "Children x ∧ Adults y ∧ Swim e ∧ Agent e x ∧ Agent e y" by blast
  then have "∃z. GroupOfPeople z ∧ Swimming z" using explanation_2 by blast
  then show ?thesis using asm by blast
qed

end
