theory question_98_0

imports Main

begin
typedecl entity
typedecl event

consts
  Man :: "entity ⇒ bool"
  Pool :: "entity ⇒ bool"
  Jumping :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Patient :: "event ⇒ entity ⇒ bool"
  Young :: "entity ⇒ bool"
  Goggles :: "entity ⇒ bool"
  Water :: "entity ⇒ bool"
  Splashing :: "event ⇒ bool"

(* Explanation 1: There is both a man jumping out of a pool. *)
axiomatization where
  explanation_1: "∃x y e. Man x ∧ Pool y ∧ Jumping e ∧ Agent e x ∧ Patient e y"

theorem hypothesis:
  (* Premise: A young man wearing goggles, is jumping out of a pool, splashing water everywhere. *)
  assumes asm: "Man x ∧ Young x ∧ Goggles x ∧ Pool y ∧ Water z ∧ Jumping e1 ∧ Agent e1 x ∧ Patient e1 y ∧ Splashing e2 ∧ Agent e2 x ∧ Patient e2 z"
  (* Hypothesis: Man jumping out of a pool. *)
  shows "∃x y e. Man x ∧ Pool y ∧ Jumping e ∧ Agent e x ∧ Patient e y"
proof -
  from asm have "Man x ∧ Pool y ∧ Jumping e1 ∧ Agent e1 x ∧ Patient e1 y" by blast
  then show ?thesis using asm by blast
qed

end
