theory question_20_7

imports Main

begin

typedecl entity

consts
  Fur :: "entity ⇒ bool"
  Feature :: "entity ⇒ bool"
  Mammals :: "entity ⇒ bool"

(* Explanation 1: Fur is a feature that is unique to and found in mammals. *)
axiomatization where
  explanation_1: "∀x. Fur x ⟶ (Feature x ∧ Mammals x)"

(* Explanation 2: Only mammals have the feature of fur. *)
axiomatization where
  explanation_2: "∀x. Mammals x ⟶ Fur x"  

theorem hypothesis:
  assumes asm: "Fur x"
  (* Hypothesis: Fur is unique to mammals. *)
  shows "Mammals x"
proof -
  from asm have "Fur x" by simp
  then have "Feature x ∧ Mammals x" using explanation_1 by blast
  then show ?thesis using `Mammals x` by blast
qed

end
