theory question_27_1
imports Main

begin

typedecl entity
typedecl event

consts
  WaterVapor :: "entity ⇒ bool"
  Cooling :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Includes :: "event ⇒ event ⇒ entity ⇒ bool"
  Chilling :: "event ⇒ bool"
  Condense :: "event ⇒ bool"

(* Explanation 1: Water vapor cooling, which includes chilling, causes that water vapor to condense. *)
axiomatization where
  explanation_1: "∀x y e1 e2 e3. WaterVapor x ∧ Cooling e1 ∧ Agent e1 x ∧ Includes e2 e1 y ∧ Chilling y ⟶ Condense e3 ∧ Agent e3 x"

theorem hypothesis:
  assumes asm: "WaterVapor x ∧ Chilling e1 ∧ Agent e1 x"
  (* Hypothesis: Water vapor chilling causes water vapor to condense. *)
  shows "∃x y e1 e2. WaterVapor x ∧ Chilling e1 ∧ Agent e1 x ∧ Condense e2 ∧ Agent e2 x"
proof -
  from asm have "WaterVapor x ∧ Chilling e1 ∧ Agent e1 x" by simp
  then obtain e2 where e2: "Condense e2 ∧ Agent e2 x" using explanation_1 by blast
  show ?thesis using asm e2 by blast
qed

end
