theory question_4_0

imports Main

begin

typedecl entity
typedecl event

consts
  Amphibians :: "entity ⇒ bool"
  Tetrapods :: "entity ⇒ bool"
  Vertebrates :: "entity ⇒ bool"
  FourLimbs :: "entity ⇒ bool"
  Ancathostega :: "entity ⇒ bool"
  Found :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  MostComplete :: "entity ⇒ bool"

(* Explanation 1: Amphibians are the first true tetrapods, or vertebrates with four limbs. *)
axiomatization where
  explanation_1: "∀x. Amphibians x ⟶ Tetrapods x ∧ Vertebrates x ∧ FourLimbs x"

(* Explanation 2: Ancathostega is one of the earliest tetrapods found, and by far the most complete. *)
axiomatization where
  explanation_2: "∀x e. Ancathostega x ∧ Found e ∧ Agent e x ⟶ Tetrapods x ∧ MostComplete x"  

theorem hypothesis:
  assumes asm: "Ancathostega x"
  (* Hypothesis: Ancathostega have four limbs. *)
  shows "FourLimbs x"
proof -
  from asm have "Tetrapods x" using explanation_2 by blast
  then have "FourLimbs x" using explanation_1 by blast
  then show ?thesis by simp
qed

end
