theory question_4_1

imports Main

begin

typedecl entity

consts
  Amphibians :: "entity ⇒ bool"
  Tetrapods :: "entity ⇒ bool"
  Vertebrates :: "entity ⇒ bool"
  FourLimbs :: "entity ⇒ bool"
  Ancathostega :: "entity ⇒ bool"

(* Explanation 1: Amphibians are the first true tetrapods, or vertebrates with four limbs. *)
axiomatization where
  explanation_1: "∀x. Amphibians x ⟶ (Tetrapods x ∧ Vertebrates x ∧ FourLimbs x)"

(* Explanation 2: Ancathostega, as one of the earliest and most complete tetrapods found, has four limbs. *)
axiomatization where
  explanation_2: "∀x. Ancathostega x ⟶ (Tetrapods x ∧ FourLimbs x)"  

theorem hypothesis:
  assumes asm: "Ancathostega x"
  (* Hypothesis: Ancathostega have four limbs. *)
  shows "FourLimbs x"
proof -
  from asm have "Ancathostega x" by simp
  then have "FourLimbs x" using explanation_2 by blast
  then show ?thesis using `FourLimbs x` by blast
qed

end
