theory question_76_5

imports Main

begin

typedecl entity
typedecl event

consts
  Organism :: "entity ⇒ bool"
  TooHot :: "entity ⇒ bool"
  Becomes :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Dies :: "event ⇒ bool"
  Decomposers :: "entity ⇒ bool"
  Cycle :: "entity ⇒ bool"
  Complete :: "event ⇒ bool"

(* Explanation 1: When an organism becomes too hot, it dies. *)
axiomatization where
  explanation_1: "∀x e1 e2. Organism x ∧ TooHot x ∧ Becomes e1 ∧ Agent e1 x ⟶ (Dies e2 ∧ Agent e2 x)"

(* Explanation 2: When an organism dies, the decomposers complete the cycle. *)
axiomatization where
  explanation_2: "(∃e1 x. Organism x ∧ Dies e1 ∧ Agent e1 x) ⟶ (∃e2 y. Decomposers y ∧ Cycle y ∧ Complete e2 ∧ Agent e2 y)"

theorem hypothesis:
  assumes asm: "Organism x ∧ TooHot x ∧ Becomes e1 ∧ Agent e1 x"
  (* Hypothesis: If an organism becomes too hot, then decomposers complete their cycle. *)
  shows "∃e2 y. Decomposers y ∧ Cycle y ∧ Complete e2 ∧ Agent e2 y"
proof -
  from asm have "Organism x ∧ TooHot x ∧ Becomes e1 ∧ Agent e1 x" by simp
  then obtain e2 where e2: "Dies e2 ∧ Agent e2 x" using explanation_1 by blast
  then have "∃e2 y. Decomposers y ∧ Cycle y ∧ Complete e2 ∧ Agent e2 y" using explanation_2 by blast
  show ?thesis using asm `∃e2 y. Decomposers y ∧ Cycle y ∧ Complete e2 ∧ Agent e2 y` by blast
qed

end
