theory question_53_10

imports Main

begin

typedecl entity

consts
  Moon :: "entity ⇒ bool"
  Earth :: "entity ⇒ bool"
  Drier :: "entity ⇒ entity ⇒ bool"

(* Explanation 1: For all entities, if one is the Moon and the other is the Earth, then the Moon is drier than the Earth. *)
axiomatization where
  explanation_1: "∃x y. Moon x ∧ Earth y ⟶ Drier x y"

theorem hypothesis:
  assumes asm: "Moon x ∧ Earth y"
  (* Hypothesis: Compared to Earth, the Moon is drier. *)
  shows "∃x y. Moon x ∧ Earth y ∧ Drier x y"
proof -
  from asm have "Moon x ∧ Earth y" by simp
  then have "Drier x y" using explanation_1 by blast
  show ?thesis using asm `Drier x y` by blast
qed

end
