theory question_61_0

imports Main

begin

typedecl entity

consts
  Earth :: "entity ⇒ bool"
  Planet :: "entity ⇒ bool"
  Sun :: "entity ⇒ bool"
  LargestBodyInOurSolarSystem :: "entity ⇒ bool"
  Star :: "entity ⇒ bool"
  CelestialObject :: "entity ⇒ bool"
  CelestialBody :: "entity ⇒ bool"
  Larger :: "entity ⇒ entity ⇒ bool"
  Moon :: "entity ⇒ bool"
  Of :: "entity ⇒ entity ⇒ bool"
  Smaller :: "entity ⇒ entity ⇒ bool"
  Jupiter :: "entity ⇒ bool"
  Bigger :: "entity ⇒ entity ⇒ bool"

(* Explanation 1: Earth is a kind of planet. *)
axiomatization where
  explanation_1: "∀x. Earth x ⟶ Planet x"

(* Explanation 2: the sun is the largest celestial body in our solar system. *)
axiomatization where
  explanation_2: "∀x. Sun x ⟶ LargestBodyInOurSolarSystem x"

(* Explanation 3: the Sun is a kind of star. *)
axiomatization where
  explanation_3: "∀x. Sun x ⟶ Star x"

(* Explanation 4: a star is a kind of celestial object; celestial body. *)
axiomatization where
  explanation_4: "∀x. Star x ⟶ CelestialObject x ∧ CelestialBody x"

(* Explanation 5: a star is usually larger than a planet. *)
axiomatization where
  explanation_5: "∀x y. Star x ∧ Planet y ⟶ Larger x y"

(* Explanation 6: a planet's moon is smaller than that planet. *)
axiomatization where
  explanation_6: "∀x y. Planet x ∧ Moon y ∧ Of y x ⟶ Smaller y x"

(* Explanation 7: Jupiter is a kind of planet. *)
axiomatization where
  explanation_7: "∀x. Jupiter x ⟶ Planet x"

(* Explanation 8: the Moon is Earth's moon. *)
axiomatization where
  explanation_8: "∀x y. Moon x ∧ Earth y ⟶ Of x y"

(* Explanation 9: a planet is a kind of celestial object; body. *)
axiomatization where
  explanation_9: "∀x. Planet x ⟶ CelestialObject x ∧ CelestialBody x"

(* Explanation 10: a moon is a kind of celestial object; body. *)
axiomatization where
  explanation_10: "∀x. Moon x ⟶ CelestialObject x ∧ CelestialBody x"

(* Explanation 11: larger; bigger is the opposite of smaller. *)
axiomatization where
  explanation_11: "∀x y. Larger x y ∧ Bigger x y ⟷ ¬Smaller x y"

theorem hypothesis:
  assumes asm: "LargestBodyInOurSolarSystem x"
  (* Hypothesis: The largest body in our solar system is the Sun. *)
  shows "Sun x"
proof -
  from asm have "LargestBodyInOurSolarSystem x" by simp
  then have "Sun x" using explanation_2 by blast
  then have "Star x" using explanation_3 by blast
  then have "CelestialObject x ∧ CelestialBody x" using explanation_4 by blast
  show ?thesis using asm `Sun x` by blast
qed

end
