theory question_66_0

imports Main

begin

typedecl entity

consts
  Sun :: "entity ⇒ bool"
  Star :: "entity ⇒ bool"
  Hottest :: "entity ⇒ bool"

(* Explanation 1: the Sun is a kind of star. *)
axiomatization where
  explanation_1: "∀x. Sun x ⟶ Star x"

(* Explanation 2: stars are some of the hottest objects. *)
axiomatization where
  explanation_2: "∀x. Star x ⟶ Hottest x"  

theorem hypothesis:
  assumes asm: "Sun x"
  (* Hypothesis: The Sun is the hottest among the Earth, Mars, and the Moon. *)
  shows "Hottest x"
proof -
  from asm have "Sun x" by simp
  then have "Star x" using explanation_1 by blast
  then have "Hottest x" using explanation_2 by blast
  show ?thesis using `Hottest x` by blast
qed

end
