theory question_24_0

imports Main

begin

typedecl entity
typedecl event
consts
  CuteCouple :: "entity ⇒ bool"
  Club :: "entity ⇒ bool"
  Couple :: "entity ⇒ bool"
  At :: "event ⇒ entity ⇒ bool"

(* Explanation 1: A cute couple at a club means a couple is at a club. *)
axiomatization where
  explanation_1: "∀x y. CuteCouple x ∧ Club y ⟶ Couple x ∧ At x y"

theorem hypothesis:
  (* Premise: A cute couple at a club. *)
  assumes asm: "CuteCouple x ∧ Club y ∧ Clubbing e  ∧ Agent e  x  ∧ At e  y "
  (* Hypothesis: The couple is at a club. *)
  shows "∃x y e. Couple x  ∧ Club y  ∧ Clubbing e  ∧ Agent e  x  ∧ At e  y "
proof -
  from asm have "CuteCouple x ∧ Club y ∧ Clubbing e  ∧ Agent e  x  ∧ At e  y " by blast
  then have "Couple x ∧ Club y ∧ Clubbing e  ∧ Agent e  x  ∧ At e  y " using explanation_1 by blast
  show ?thesis using `Couple x` `Club y` by blast
qed

end
