theory question_31_8

imports Main

begin

typedecl entity
typedecl event
consts
 Child :: "entity ⇒ bool"
 Walking :: "event ⇒ bool"
 Eating :: "event ⇒ bool"
 Cheerios :: "entity ⇒ bool"
 Agent :: "event ⇒ entity ⇒ bool"
 Patient :: "event ⇒ entity ⇒ bool"
 In :: "event ⇒ entity ⇒ bool"
 Consuming :: "event ⇒ bool"
 Snacking :: "event ⇒ bool"
 Performing :: "event ⇒ bool"
 Occurring :: "event ⇒ bool"
 Enjoying :: "event ⇒ bool"
 Simultaneously :: "event ⇒ bool"

(* Premise: A young child with dark shoulder length hair, in a yellow shirt and pink pants, is walking eating cheerios out of a ziplock bag. *)
assumes asm: "YoungChild x  ∧ DarkShoulderLengthHair x  ∧ YellowShirt y  ∧ PinkPants z  ∧ Walking e  ∧ Eating e  ∧ Cheerios y  ∧ Agent e  x  ∧ Patient e  y  ∧ In e  z "

(* Hypothesis: A child eats cheerios. *)
shows "∃x y e. Child x  ∧ Eating e  ∧ Cheerios y  ∧ Agent e  x  ∧ Patient e  y "
proof -
 from asm have "YoungChild x" by blast
 from this have "Child x" using explanation_1 by blast
 from asm have "Eating e" by blast
 from this have "Cheerios y" using explanation_1 by blast
 show ?thesis using `Child x` `Eating e` `Cheerios y` by blast
qed

end
