theory question_58_5

imports Main

begin

typedecl entity
typedecl event
consts
  Man :: "entity ⇒ bool"
  GreenCelticSleevelessJerseyShirt :: "entity ⇒ bool"
  ShortStoneWashedJeanShorts :: "entity ⇒ bool"
  Sitting :: "entity ⇒ bool"
  Eating :: "event ⇒ bool"
  HavingMeal :: "entity ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"

(* Explanation 1: If a man is eating, then he is having a meal. *)
axiomatization where
  explanation_1: "∀x. Eating x ⟶ HavingMeal x"

(* Explanation 2: If a man is having a meal, then he is sitting. *)
axiomatization where
  explanation_2: "∀x. HavingMeal x ⟶ Sitting x"

theorem hypothesis:
  (* Premise: A man in a green Celtic sleeveless jersey shirt and short stone washed jean shorts sitting and eating. *)
  assumes asm: "Man x  ∧ GreenCelticSleevelessJerseyShirt y  ∧ ShortStoneWashedJeanShorts z  ∧ Sitting e  ∧ Eating e  ∧ Agent e  x "
  (* Hypothesis: The man is having a meal. *)
  shows "∃x e. Man x  ∧ HavingMeal e  ∧ Agent e  x "
proof -
  from asm have "Man x" by blast
  from this have "HavingMeal e" using explanation_1 by blast
  from this have "Sitting e" using explanation_2 by blast
  show ?thesis using `Man x` `HavingMeal e` `Sitting e` by blast
qed

end
