theory question_66_0

imports Main

begin

typedecl entity
typedecl event
consts
  Bartender :: "entity ⇒ bool"
  Person :: "entity ⇒ bool"
  WearingBlack :: "entity ⇒ bool"

(* Explanation 1: A bartender, who is a person, is wearing black. *)
axiomatization where
  explanation_1: "∀x. Bartender x ∧ Person x ∧ WearingBlack x"

theorem hypothesis:
  (* Premise: A male bartender dressed in all black with his sleeves rolled up to elbow height making a drink in a martini glass. *)
  assumes asm: "MaleBartender x ∧ DressedInBlack x ∧ SleevesRolledUp x ∧ Making e ∧ Drink y ∧ MartiniGlass y ∧ Agent e x ∧ Patient e y"
  (* Hypothesis: A person in black. *)
  shows "∃x. Person x ∧ WearingBlack x"
proof -
  from asm have "Bartender x" by blast
  from this have "Person x" using explanation_1 by blast
  from asm have "Black x" by blast
  show ?thesis using `Person x` `Black x` by blast
qed

end
