theory question_67_5

imports Main

begin

typedecl entity
typedecl event

consts
 OlderMale :: "entity ⇒ bool"
 RiverBoatTour :: "entity ⇒ bool"
 Boat :: "entity ⇒ bool"
 MeansOfTransportation :: "event ⇒ bool"
 Sitting :: "event ⇒ bool"
 Participant :: "event ⇒ bool"
 Participating :: "event ⇒ bool"
 TakingPlace :: "event ⇒ bool"
 Transporting :: "event ⇒ bool"
 Starting :: "event ⇒ bool"
 Ending :: "event ⇒ bool"
 Duration :: "event ⇒ bool"
 Present :: "event ⇒ bool"
 Guiding :: "event ⇒ bool"
 Route :: "event ⇒ bool"
 Following :: "event ⇒ bool"

(* Premise: Two older males sitting together on a boat. *)
assumes asm: "OlderMale x  ∧ OlderMale y  ∧ Boat z  ∧ Sitting e  ∧ Agent e  x  ∧ Agent e  y  ∧ Patient e  z "

(* Hypothesis: A river boat tour exists and is an entity. *)
shows: "∃x. RiverBoatTour(x) ⟶ Exists(x) ∧ Entity(x)"

proof -
 from asm have "OlderMale x ∧ OlderMale y ∧ Boat z ∧ Sitting e ∧ Agent e x ∧ Agent e y ∧ Patient e z" by blast
 then have "RiverBoatTour x ∧ Entity x" using explanation_2 by blast
 then show ?thesis using `RiverBoatTour x` `Entity x` by blast
qed

end
