theory question_67_6

imports Main

begin

typedecl entity
typedecl event

consts
 Male :: "entity ⇒ bool"
 OlderMale :: "entity ⇒ bool"
 RiverBoatTour :: "entity ⇒ bool"
 Participate :: "event ⇒ bool"
 Agent :: "event ⇒ entity ⇒ bool"
 Patient :: "event ⇒ entity ⇒ bool"
 MeansOfTransportation :: "entity ⇒ bool"
 Transport :: "event ⇒ entity ⇒ bool"
 Boat :: "entity ⇒ bool"
 Exist :: "entity ⇒ bool"
 Duration :: "event ⇒ bool"
 Present :: "event ⇒ bool"
 In :: "event ⇒ entity ⇒ bool"
 Route :: "entity ⇒ bool"
 Follow :: "event ⇒ entity ⇒ bool"
 Person :: "entity ⇒ bool"
 GroupOfPeople :: "entity ⇒ bool"
 Guide :: "event ⇒ bool"
 Start :: "entity ⇒ bool"
 End :: "entity ⇒ bool"
 Sit :: "event ⇒ bool"

(* Premise: Two older males sitting together on a boat. *)
assumes asm: "OlderMale x  ∧ OlderMale y  ∧ Sit x  y "

(* Hypothesis: A river boat tour exists and is an entity. *)
shows "∃x. RiverBoatTour x  ∧ Exist x "

proof -
 from asm have "OlderMale x ∧ OlderMale y ∧ Sit x y" by blast
 then have "Person x ∧ Person y ∧ Agent x ∧ Patient y ∧ MeansOfTransportation z ∧ Transport e1 ∧ Boat b ∧ Duration d ∧ Present p ∧ In i ∧ Route r ∧ Follow f ∧ Guide g ∧ Start s ∧ End e ∧ Sit t" using explanation_1 by blast
 then show ?thesis using `RiverBoatTour x ∧ Exist x` by blast
qed

end
