theory question_67_7

imports Main

begin

typedecl entity
typedecl event

consts
 OlderMale :: "entity ⇒ bool"
 Participant :: "event ⇒ bool"
 RiverBoatTour :: "event ⇒ bool"
 MeansOfTransportation :: "entity ⇒ bool"
 Boat :: "entity ⇒ bool"
 Exists :: "entity ⇒ bool"
 Duration :: "event ⇒ bool"
 Present :: "event ⇒ bool"
 Throughout :: "event ⇒ bool"
 Route :: "entity ⇒ bool"
 Specific :: "entity ⇒ bool"
 Guide :: "event ⇒ bool"
 Person :: "entity ⇒ bool"
 Group :: "entity ⇒ bool"
 Guides :: "event ⇒ bool"
 Start :: "event ⇒ bool"
 End :: "event ⇒ bool"
 SpecificLocation :: "entity ⇒ bool"
 Involved :: "event ⇒ bool"
 Sit :: "event ⇒ bool"
 Agent :: "event ⇒ entity ⇒ bool"
 Patient :: "event ⇒ entity ⇒ bool"
 During :: "event ⇒ event ⇒ bool"
 UsedIn :: "entity ⇒ event ⇒ bool"

(* Premise: Two older males sitting together on a boat. *)
assumes asm: "Male x  ∧ Male y  ∧ Sit e  ∧ Agent e  x  ∧ Patient e  y "

(* Hypothesis: A river boat tour is a means of transportation for the two older males. *)
shows "∃x y. RiverBoatTour x  ∧ MeansOfTransportation y  ∧ For y  x "
proof -
 from asm have "Male x ∧ Male y ∧ Sit e ∧ Agent e x ∧ Patient e y" by blast
 then have "Person x ∧ Person y ∧ Boat b ∧ MeansOfTransportation m" using explanation_1 by blast
 then have "For y x" using explanation_2 by blast
 then show ?thesis using `Person x` `Person y` `Boat b` `MeansOfTransportation m` by blast
qed

end
