theory question_7_10

imports Main

begin

typedecl entity
typedecl event
consts
  LittleGirl :: "entity ⇒ bool"
  YellowRope :: "entity ⇒ bool"
  Jumping :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Over :: "event ⇒ entity ⇒ bool"
  Girl :: "entity ⇒ bool"

(* Explanation 1: If a little girl exists and she is jumping over a yellow rope, then she is jumping rope and there exists a girl who jumps rope. *)
axiomatization where
  explanation_1: "∃x y e. LittleGirl x ∧ YellowRope y ∧ Jumping e ∧ Agent e x ∧ Over e y"

(* Explanation 2: If a girl exists and she is jumping rope, then there exists a girl who jumps rope. *)
axiomatization where
  explanation_2: "∃x e. Girl x ∧ Jumping e ∧ Agent e x"

theorem hypothesis:
  (* Premise: A little girl is jumping over a yellow rope. *)
  assumes asm: "LittleGirl x ∧ YellowRope y ∧ Jumping e ∧ Agent e x ∧ Over e y"
  (* Hypothesis: A girl jumps rope. *)
  shows "∃x e. Girl x ∧ Jumping e ∧ Agent e x"
proof -
  from asm have "LittleGirl x" by blast
  from this have "Jumping e" using explanation_1 by blast
  from asm have "YellowRope y" by blast
  from this have "Agent e x" using explanation_1 by blast
  from asm have "Over e y" by blast
  show ?thesis using `Girl x` `Jumping e` `Agent e x` `Over e y` by blast
qed

end
