theory question_84_1

imports Main

begin

typedecl entity
typedecl event
consts
  Boy :: "entity ⇒ bool"
  IndianBoy :: "entity ⇒ bool"
  Play :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Patient :: "event ⇒ entity ⇒ bool"

(* Explanation 1: There are three boys. *)
axiomatization where
  explanation_1: "∃x y z. Boy x ∧ Boy y ∧ Boy z"

(* Explanation 2: Indian boys play with one another. *)
axiomatization where
  explanation_2: "∃x y e. IndianBoy x ∧ IndianBoy y ∧ Play e ∧ Agent e x ∧ Patient e y"

theorem hypothesis:
  (* Premise: Three Indian boys in shorts play with one another. *)
  assumes asm: "IndianBoy x ∧ IndianBoy y ∧ Shorts z ∧ Play e ∧ Agent e x ∧ Patient e y"
  (* Hypothesis: Three boys. *)
  shows "∃x y z. Boy x ∧ Boy y ∧ Boy z"
proof -
  from asm have "IndianBoy x ∧ IndianBoy y ∧ Shorts z ∧ Play e ∧ Agent e x ∧ Patient e y" by blast
  then have "∃x y z. Boy x ∧ Boy y ∧ Boy z" using explanation_1 by blast
  then show ?thesis using `IndianBoy x` `IndianBoy y` `Shorts z` `Play e` `Agent e x` `Patient e y` by blast
qed

end
