theory question_87_0

imports Main

begin

typedecl entity
typedecl event

consts
 SmilingYoungGirl :: "entity ⇒ bool"
 Holding :: "event ⇒ entity ⇒ bool"
 YellowFlower :: "entity ⇒ bool"
 BlondeHair :: "entity ⇒ bool"
 BlueEyes :: "entity ⇒ bool"
 PinkShirt :: "entity ⇒ bool"

(* Explanation 1: A smiling young girl can also be holding a yellow flower. *)
axiomatization where
 explanation_1: "∀x. SmilingYoungGirl x ∧ Holding x YellowFlower"

theorem hypothesis:
 (* Premise: A smiling young girl with blond-hair, blue eyes, and a pink shirt, is holding a yellow flower towards the viewer outside. *)
 assumes asm: "SmilingYoungGirl x  ∧ BlondeHair y  ∧ BlueEyes z  ∧ PinkShirt z  ∧ Holding e  YellowFlower  ∧ Agent e  x  ∧ Patient e  y  ∧ InFrontOf x  z "
 (* Hypothesis: A smiling young girl with blond-hair. *)
 shows "∃x. SmilingYoungGirl x  ∧ BlondeHair x "
proof -
 from asm have "SmilingYoungGirl x" by blast
 from this have "BlondeHair x" using explanation_1 by blast
 show ?thesis using `SmilingYoungGirl x` `BlondeHair x` by blast
qed

end
