theory question_91_7

imports Main

begin

typedecl entity
typedecl event
consts
 Child :: "entity ⇒ bool"
 Outside :: "entity ⇒ bool"
 Playing :: "event ⇒ bool"
 Agent :: "event ⇒ entity ⇒ bool"
 Existence :: "event ⇒ entity ⇒ bool"

(* Explanation 1: A child plays. *)
axiomatization where
 explanation_1: "∃x e. Child(x) ∧ Playing(e) ∧ Agent(e, x)"

(* Premise: Several children playing outside. *)
assumes asm: "Child x  ∧ Outside y  ∧ Playing e  ∧ Agent e  x  ∧ Plural x "

(* Hypothesis: There are children playing. *)
shows "∃x e. Child x  ∧ Playing e  ∧ Agent e  x "
proof -
 from asm have "Child x" by blast
 then have "Playing e" using explanation_1 by blast
 then show ?thesis using `Child x` `Playing e` by blast
qed

end
