theory question_91_8

imports Main

begin

typedecl entity
typedecl event

consts
 Child :: "entity ⇒ bool"
 Playing :: "event ⇒ bool"
 Outside :: "entity ⇒ bool"
 Agent :: "event ⇒ entity ⇒ bool"

(* Explanation 1: There are children playing. *)
axiomatization where
 explanation_1: "∃x e. Child(x) ∧ Playing(e) ∧ Agent(e, x)"

(* Premise: Several children playing outside *)
assumes asm: "Child x  ∧ Playing e  ∧ Agent e  x  ∧ Plural x  ∧ Outside x "

(* Hypothesis: A child exists. *)
shows "∃x. Child x "
proof -
 from asm have "Child x" by blast
 then have "Playing e" using explanation_1 by blast
 then show ?thesis using `Child x` `Playing e` by blast
qed

end
