theory question_91_9

imports Main

begin

typedecl entity
typedecl event

consts
 Children :: "entity ⇒ bool"
 Outside :: "entity ⇒ bool"
 Playing :: "event ⇒ bool"
 Agent :: "event ⇒ entity ⇒ bool"
 Location :: "event ⇒ entity ⇒ bool"
 PlayingOutside :: "event ⇒ bool"
 PropertyOfChildren :: "entity ⇒ bool"
 LocationOfChildrenPlaying :: "entity ⇒ bool"
 ExistenceOfChildren :: "entity ⇒ bool"

(* Premise: exists x y z e. Children(x) ∧ Outside(y) ∧ Playing(e) ∧ Agent(e, x) ∧ Location(y, e) ∧ Existence(z) ∧ In(e, z) *)
assumes asm: "Children x  ∧ Outside y  ∧ Playing e  ∧ Agent e  x  ∧ Location y  e  ∧ Existence z  ∧ In e  z "

(* Hypothesis: ∃x e. Children(x) ∧ Playing(e) ∧ Agent(e, x) *)
shows "∃x e. Children x  ∧ Playing e  ∧ Agent e  x "
proof -
 from asm have "Children x" by blast
 from this have "Playing e" using explanation_1 by blast
 show ?thesis using `Children x` `Playing e` by blast
qed

end
