theory question_92_9

imports Main

begin

typedecl entity
typedecl event

consts
 Tourist :: "entity ⇒ bool"
 WantToSeeSurroundingView :: "entity ⇒ bool"
 InsideGlassElevator :: "entity ⇒ bool"
 LookingOut :: "event ⇒ bool"
 Agent :: "event ⇒ entity ⇒ bool"
 Patient :: "event ⇒ entity ⇒ bool"
 Prefer :: "entity ⇒ (entity ⇒ bool)"
 RideInGlassElevator :: "entity ⇒ bool"
 EnjoyViewOutside :: "entity ⇒ bool"
 MoveBetweenFloors :: "entity ⇒ bool"
 GlassElevator :: "entity ⇒ bool"
 OpportunityForTouristToObserveSurroundingWithoutObstruction :: "entity ⇒ bool"
 JoyInLookingOutOfGlassElevator :: "entity ⇒ bool"
 UniquePerspectiveOfSurroundingArea :: "entity ⇒ bool"
 GlassElevatorDesign :: "entity ⇒ bool"
 UnobstructedViewOfOutsideEnvironment :: "entity ⇒ bool"
 UseGlassElevatorToObserveExternalSurrounding :: "entity ⇒ bool"
 TravelWithinBuilding :: "entity ⇒ bool"
 FacilitateTouristDesireToExploreSurroundingVisually :: "entity ⇒ bool"
 AppreciateTransparencyOfGlassElevator :: "entity ⇒ bool"
 EnableGazeOutsideWhileMovingVertically :: "entity ⇒ bool"

(* Premise: Three glass elevators with people inside of them. *)
assumes asm: "GlassElevator x  ∧ PersonInside y  ∧ LookingOut e  ∧ Agent e  x  ∧ Patient e  y "

(* Hypothesis: Tourists looking out of glass elevators. *)
shows "∃x. Tourist x  ∧ LookingOut x "
proof -
 from asm have "GlassElevator x" by blast
 from this have "Tourist x" using explanation_1 by blast
 from asm have "LookingOut e" by blast
 from this have "LookingOut x" using explanation_2 by blast
 show ?thesis using `Tourist x` `LookingOut x` by blast
qed

end
