theory question_93_6

imports Main

begin

typedecl entity
typedecl event

consts
 Woman :: "entity ⇒ bool"
 Animals :: "entity ⇒ bool"
 Broom :: "entity ⇒ bool"
 Chasing :: "event ⇒ bool"
 Agent :: "event ⇒ entity ⇒ bool"
 Patient :: "event ⇒ entity ⇒ bool"
 Object :: "event ⇒ entity ⇒ bool"
 Lambs :: "entity ⇒ bool"

(* Explanation 1: If there is a woman and some animals, then there are animals that are not women. *)
axiomatization where
 explanation_1: "∃x. Woman x ∧ Animals x ⟶ ¬Woman x"

theorem hypothesis:
 (* Premise: Old woman chasing away two lambs with a broom. *)
 assumes asm: "Woman x ∧ Broom y ∧ Chasing e ∧ Agent e x ∧ Patient e y ∧ Object e z ∧ Lambs z"
 (* Hypothesis: There is a woman and some animals. *)
 shows "∃x. Woman x ∧ Animals x"
proof -
 from asm have "Woman x" by blast
 from asm have "Animals x" by blast
 show ?thesis using `Woman x` `Animals x` by blast
qed

end
