theory question_99_0

imports Main

begin

typedecl entity
typedecl event
consts
 Dog :: "entity ⇒ bool"
 Grass :: "entity ⇒ bool"
 Running :: "event ⇒ bool"
 Agent :: "event ⇒ entity ⇒ bool"
 Patient :: "event ⇒ entity ⇒ bool"

(* Explanation 1: A dog could also be running on grass. *)
axiomatization where
 explanation_1: "∀x y e. Dog x ∧ Running e ∧ Grass y ∧ Agent e x ∧ Patient e y"

theorem hypothesis:
 (* Premise: A dog running on grass *)
 assumes asm: "Dog x  ∧ Running e  ∧ Grass y  ∧ Agent e  x  ∧ Patient e  y "
 (* Hypothesis: A dog is on the grass *)
 shows "∃x. Dog x  ∧ OnGrass x "
proof -
 from asm have "Dog x ∧ Running e ∧ Grass y" by blast
 then have "Dog x ∧ OnGrass x" using explanation_1 by blast
 show ?thesis using `Dog x` `OnGrass x` by blast
qed

end
