theory question_99_3

imports Main

begin

typedecl entity
typedecl event

consts
 Dog :: "entity ⇒ bool"
 Grass :: "entity ⇒ bool"
 Ability :: "entity ⇒ bool"
 Run :: "event ⇒ bool"
 Agent :: "event ⇒ entity ⇒ bool"
 Patient :: "event ⇒ entity ⇒ bool"
 In :: "event ⇒ entity ⇒ bool"
 SuitableSurface :: "entity ⇒ bool"
 For :: "entity ⇒ entity ⇒ bool"
 DogRun :: "entity ⇒ bool"
 PhysicallyPresent :: "event ⇒ entity ⇒ bool"

(* Premise: A dog running on grass *)
assumes asm: "Dog x  ∧ Grass y  ∧ Running e  ∧ Agent e  x  ∧ Patient e  y "

(* Hypothesis: A dog is on the grass. *)
shows "∃x y e. Dog x  ∧ Grass y  ∧ Being e  ∧ Agent e  x  ∧ Patient e  y "
proof -
 from asm have "Dog x" by blast
 from this have "Ability x" using explanation_1 by blast
 from asm have "Grass y" by blast
 from this have "SuitableSurface y" using explanation_2 by blast
 from asm have "Running e" by blast
 from this have "PhysicallyPresent e" using explanation_3 by blast
 show ?thesis using `Dog x` `Grass y` `Ability x` `SuitableSurface y` `PhysicallyPresent e` by blast
qed

end
