theory question_20_0

imports Main

begin

typedecl entity
typedecl event

consts
  Mammal :: "entity ⇒ bool"
  Fur :: "entity ⇒ bool"
  Hair :: "entity ⇒ bool"

(* Explanation 2: All mammals have fur or hair. *)
axiomatization where
  explanation_2: "∀x. Mammal x ⟶ (∃y. Fur y ∨ Hair y)"

theorem hypothesis:
  assumes asm: "Mammal x"
  (* Hypothesis: Fur is unique to mammals. *)
  shows "∃y. Fur y ∧ Mammal y"
proof -
  from asm have "Mammal x" by simp
  then obtain e1 where e1: "Fur y ∨ Hair y" using explanation_2 by blast
  then have "Fur y" using e1 by simp
  show ?thesis using asm Fur y by blast
qed

end
