theory question_4_3

imports Main

begin

typedecl entity
typedecl event

consts
  Tetrapods :: "entity ⇒ bool"
  Vertebrates :: "entity ⇒ bool"
  FourLimbs :: "entity ⇒ bool"
  Ancathostega :: "entity ⇒ bool"

(* Explanation 1: Tetrapods are vertebrates with four limbs. *)
axiomatization where
  explanation_1: "∀x. Tetrapods x ∧ Vertebrates x ∧ FourLimbs x"

(* Explanation 2: Ancathostega is a tetrapod with four limbs. *)
axiomatization where
  explanation_2: "∀x. Ancathostega x ∧ Tetrapods x ∧ FourLimbs x"

(* Explanation 3: Tetrapods have four limbs. *)
axiomatization where
  explanation_3: "∀x. Tetrapods x ∧ FourLimbs x"

theorem hypothesis:
  assumes asm: "Ancathostega x"
  (* Hypothesis: Ancathostega have four limbs. *)
  shows "∃x. Tetrapods x ∧ FourLimbs x"
proof -
  from asm have "Ancathostega x" by simp
  then obtain e1 where e1: "Tetrapods x ∧ Vertebrates x ∧ FourLimbs x" using explanation_1 by blast
  then have "Tetrapods x" using e1 by simp
  then have "FourLimbs x" using e1 by simp
  show ?thesis using asm Tetrapods x FourLimbs x by blast
qed

end
