theory question_4_4

imports Main

begin

typedecl entity
typedecl event

consts
  Tetrapods :: "entity ⇒ bool"
  Vertebrates :: "entity ⇒ bool"
  FourLimbs :: "entity ⇒ bool"

(* Explanation 1: Tetrapods are vertebrates with four limbs. *)
axiomatization where
  explanation_1: "∀x. Tetrapods x ∧ Vertebrates x ∧ FourLimbs x"

(* Explanation 2: All tetrapods have four limbs. *)
axiomatization where
  explanation_2: "∀x. Tetrapods x ⟶ FourLimbs x"  

theorem hypothesis:
  assumes asm: "Tetrapods x ∧ Vertebrates x"
  (* Hypothesis: Ancathostega have four limbs. *)
  shows "∃x. FourLimbs x ∧ Ancathostega x"
proof -
  from asm have "Tetrapods x ∧ Vertebrates x" by simp
  then obtain e1 where e1: "Tetrapods x ∧ FourLimbs x" using explanation_1 by blast
  then have "FourLimbs x" using e1 by simp
  show ?thesis using asm "FourLimbs x" by blast
qed

end
