theory question_75_0

imports Main

begin

typedecl entity
typedecl event

consts
  Rock :: "entity ⇒ bool"
  Heat :: "entity ⇒ bool"
  Pressure :: "entity ⇒ bool"
  Change :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Patient :: "event ⇒ entity ⇒ bool"
  Marble :: "entity ⇒ bool"
  MetamorphicRock :: "entity ⇒ bool"

(* Explanation 1: Extreme heat and pressure change rock into metamorphic rock. *)
axiomatization where
  explanation_1: "∀x y e. Rock x ∧ Heat y ∧ Pressure y ∧ Change e ∧ Agent e x ∧ Patient e y"

(* Explanation 2: Marble is a form of metamorphic rock. *)
axiomatization where
  explanation_2: "∀x. Marble x ∧ MetamorphicRock x"

theorem hypothesis:
  assumes asm: "Rock x ∧ Heat y ∧ Pressure y"
  (* Hypothesis: Extreme heat and pressure change rock into marble. *)
  shows "∃x y e. Rock x ∧ Heat y ∧ Pressure y ∧ Change e ∧ Agent e x ∧ Patient e y ∧ Marble x"
proof -
  from asm have "Rock x ∧ Heat y ∧ Pressure y" by simp
  then obtain e1 where e1: "Change e1 ∧ Agent e1 x ∧ Patient e1 y" using explanation_1 by blast
  then have "MetamorphicRock z" using e1 by simp
  then have "Marble z" using explanation_2 by simp
  show ?thesis using asm e1 `MetamorphicRock z` `Marble z` by blast
qed

end
