theory question_77_2

imports Main

begin

typedecl entity
typedecl event

consts
  Mollusks :: "entity ⇒ bool"
  Shell :: "entity ⇒ bool"
  BivalveMollusk :: "entity ⇒ bool"
  Mussels :: "entity ⇒ bool"

(* Explanation 1: Most mollusks have shells. *)
axiomatization where
  explanation_1: "∀x. Mollusks x ∧ Shell x"

(* Explanation 2: Mussels are a type of bivalve mollusk and have shells. *)
axiomatization where
  explanation_2: "∀x. Mussels x ∧ BivalveMollusk x ∧ Shell x"

theorem hypothesis:
  assumes asm: "Mussels x"
  (* Hypothesis: Mussels have a shell. *)
  shows "∃x. Mollusks x ∧ Shell x"
proof -
  from asm have "Mussels x" by simp
  then obtain e1 where e1: "Mollusks x ∧ Shell x" using explanation_1 by blast
  then have "BivalveMollusk x" using explanation_2 by blast
  have conclusion: "Mollusks x ∧ Shell x" using e1 by simp
  show ?thesis using asm conclusion `BivalveMollusk x` by blast
qed

end
