theory question_5_9

imports Main

begin

typedecl entity
typedecl event

consts
  Finding :: "entity ⇒ bool"
  Planets :: "entity ⇒ bool"
  LargerThanPluto :: "entity ⇒ bool"
  Questioned :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Patient :: "event ⇒ entity ⇒ bool"
  SmallSize :: "entity ⇒ bool"
  ComparedToOtherPlanets :: "entity ⇒ bool"
  Supported :: "event ⇒ bool"
  Deduced :: "event ⇒ bool"
  Comparison :: "entity ⇒ bool"
  ObjectsInSolarSystem :: "entity ⇒ bool"
  SparkedDebate :: "event ⇒ bool"
  Investigated :: "entity ⇒ bool"
  CriteriaForPlanet :: "entity ⇒ bool"
  FoundThatItDoesNotMeet :: "entity ⇒ bool"
  EvidenceGatheredByScientists :: "entity ⇒ bool"
  SuggestsThatPlutoShouldNotBeClassifiedAsPlanet :: "entity ⇒ bool"

1. ∀x y z e1. Finding(x) ∧ Planets(y) ∧ LargerThanPluto(z) ∧ Questioned(e1) ∧ Agent(e1, x) ∧ Patient(e1, y)

2. ¬Planet(Pluto) ∧ ClearOrbit(Pluto)

3. ∃x y z e1. Scientists(x) ∧ Questioned(e1) ∧ SmallSize(z) ∧ ComparedToOtherPlanets(y) ∧ Agent(e1, x) ∧ Patient(e1, y)

4. ∀x y z e1. Finding(x) ∧ Planets(y) ∧ LargerThanPluto(z) ∧ Supported(e1) ∧ Agent(e1, x) ∧ Patient(e1, y)

5. ∃x y z e1. Pluto(x) ∧ SmallSize(y) ∧ FailureToClearOrbit(z) ∧ Deduced(e1) ∧ Agent(e1, x) ∧ Patient(e1, y)

6. ∃x y z e1. Comparison(x) ∧ ObjectsInSolarSystem(y) ∧ Questioned(e1) ∧ Agent(e1, x) ∧ Patient(e1, y)

7. ∃x y z e1. Discovery(x) ∧ SmallerThanEarthsMoon(y) ∧ SparkedDebate(e1) ∧ Agent(e1, x) ∧ Patient(e1, y)

8. ∃x y z e1. Scientists(x) ∧ Investigated(Pluto) ∧ CriteriaForPlanet(y) ∧ FoundThatItDoesNotMeet(z) ∧ Agent(e1, x) ∧ Patient(e1, y)

9. ∃x y z e1. EvidenceGatheredByScientists(x) ∧ SuggestsThatPlutoShouldNotBeClassifiedAsPlanet(y) ∧ Agent(e1, x) ∧ Patient(e1, y)

theorem hypothesis:
 assumes asm: ""
 shows ""
proof -

1. ∃x y z e1. Pluto(x) ∧ SmallSize(y) ∧ FailureToClearOrbit(z) ∧ Deduced(e1) ∧ Agent(e1, x) ∧ Patient(e1, y)
2. ∃x y z e1. Comparison(x) ∧ ObjectsInSolarSystem(y) ∧ Questioned(e1) ∧ Agent(e1, x) ∧ Patient(e1, y)
3. ∃x y z e1. Discovery(x) ∧ SmallerThanEarthsMoon(y) ∧ SparkedDebate(e1) ∧ Agent(e1, x) ∧ Patient(e1, y)
4. ∃x y z e1. Scientists(x) ∧ Investigated(Pluto) ∧ CriteriaForPlanet(y) ∧ FoundThatItDoesNotMeet(z) ∧ Agent(e1, x) ∧ Patient(e1, y)
5. ∃x y z e1. EvidenceGatheredByScientists(x) ∧ SuggestsThatPlutoShouldNotBeClassifiedAsPlanet(y) ∧ Agent(e1, x) ∧ Patient(e1, y)

1. ∀x y z e1. Finding(x) ∧ Planets(y) ∧ LargerThanPluto(z) ∧ Supported(e1) ∧ Agent(e1, x) ∧ Patient(e1, y)
2. ∀x y z e1. Comparison(x) ∧ ObjectsInSolarSystem(y) ∧ Questioned(e1) ∧ Agent(e1, x) ∧ Patient(e1, y)
3. ∀x y z e1. Discovery(x) ∧ SmallerThanEarthsMoon(y) ∧ SparkedDebate(e1) ∧ Agent(e1, x) ∧ Patient(e1, y)
4. ∀x y z e1. Scientists(x) ∧ Investigated(Pluto) ∧ CriteriaForPlanet(y) ∧ FoundThatItDoesNotMeet(z) ∧ Agent(e1, x) ∧ Patient(e1, y)
5. ∀x y z e1. EvidenceGatheredByScientists(x) ∧ SuggestsThatPlutoShouldNotBeClassifiedAsPlanet(y) ∧ Agent(e1, x) ∧ Patient(e1, y)

theorem hypothesis:
 assumes asm: ""
 shows ""
proof -  
  
  
qed

end
