theory question_90_0

imports Main

begin
typedecl entity
typedecl event
consts
  Workers :: "entity ⇒ bool"
  Grass :: "entity ⇒ bool"
  Pulling :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Patient :: "event ⇒ entity ⇒ bool"
  Bent :: "event ⇒ bool"
  Three :: "entity ⇒ bool"
  While :: "event ⇒ event ⇒ bool"

(* Explanation 1: Workers are pulling grass while they bent over. *)
axiomatization where
  explanation_1: "∃x y e1 e2. Workers x ∧ Grass y ∧ Pulling e1 ∧ Agent e1 x ∧ Patient e1 y ∧ Bent e2 ∧ Agent e2 x ∧ While e1 e2"

theorem hypothesis:
  (* Premise: Three workers bent over pulling grass. *)
  assumes asm: "Workers x ∧ Three x ∧ Grass y ∧ Bent e1 ∧ Agent e1 x ∧ Pulling e2 ∧ Agent e2 x ∧ Patient e2 y ∧ While e1 e2"
  (* Hypothesis: Three workers bent over. *)
  shows "∃x e. Workers x ∧ Three x ∧ Bent e ∧ Agent e x"
proof -
  from asm have "Workers x ∧ Three x ∧ Bent e1 ∧ Agent e1 x" by blast
  then show ?thesis using asm by blast
qed

end
