theory question_91_0

imports Main

begin
typedecl entity
typedecl event
consts
  Children :: "entity ⇒ bool"
  Playing :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Several :: "entity ⇒ bool"
  Outside :: "entity ⇒ bool"
  In :: "entity ⇒ entity ⇒ bool"

(* Explanation 1: The children are playing, the second sentence only removed the detail of setting. *)
axiomatization where
  explanation_1: "∃x e. Children x ∧ Playing e ∧ Agent e x"

theorem hypothesis:
  (* Premise: Several children playing outside *)
  assumes asm: "Several x ∧ Children x ∧ Outside y ∧ Playing e ∧ Agent e x ∧ In x y"
  (* Hypothesis: There are children playing. *)
  shows "∃x e. Children x ∧ Playing e ∧ Agent e x"
proof -
  from asm have "Children x ∧ Playing e ∧ Agent e x" by blast
  then show ?thesis using explanation_1 by blast
qed

end
