theory question_21_1

imports Main

begin

typedecl entity

consts
  Birds :: "entity ⇒ bool"
  EndothermicTetrapodVertebrate :: "entity ⇒ bool"
  ClassAves :: "entity ⇒ bool"

(* Explanation 1: Birds are the only known endothermic tetrapod vertebrates. *)
axiomatization where
  explanation_1: "∀x. Birds x ⟷ EndothermicTetrapodVertebrate x"

(* Explanation 2: Class Aves is for birds and only birds. *)
axiomatization where
  explanation_2: "∀x. ClassAves x ⟷ Birds x"

theorem hypothesis:
  assumes asm: "EndothermicTetrapodVertebrate x"
  (* Hypothesis: An endothermic tetrapod vertebrate would be animals in the class aves. *)
  shows "ClassAves x"
proof -
  from asm have "EndothermicTetrapodVertebrate x" by simp
  then have "Birds x" using explanation_1 by blast
  then show ?thesis using explanation_2 by blast
qed

end
