theory question_4_2

imports Main

begin

typedecl entity

consts
  Ancathostega :: "entity ⇒ bool"
  Tetrapod :: "entity ⇒ bool"
  Earliest :: "entity ⇒ bool"
  MostComplete :: "entity ⇒ bool"
  FourLimbs :: "entity ⇒ bool"

(* Explanation 1: Ancathostega is a type of tetrapod, and one of the earliest and most complete found. *)
axiomatization where
  explanation_1: "∃x. Ancathostega x ∧ Tetrapod x ∧ Earliest x ∧ MostComplete x"

(* Explanation 2: All tetrapods are defined to have four limbs. *)
axiomatization where
  explanation_2: "∀x. Tetrapod x ⟶ FourLimbs x"

(* Explanation 3: If an entity is a tetrapod, then it has four limbs. *)
axiomatization where
  explanation_3: "∀x. Tetrapod x ⟶ FourLimbs x"

theorem hypothesis:
  assumes asm: "Ancathostega x"
  (* Hypothesis: Ancathostega have four limbs. *)
  shows "FourLimbs x"
proof -
  have "Ancathostega x" by fact
  then obtain y where "Ancathostega y ∧ Tetrapod y ∧ Earliest y ∧ MostComplete y" using explanation_1 by blast
  then have "Tetrapod y" by simp
  then have "FourLimbs y" using explanation_2 by blast
  then have "∀x. Tetrapod x ⟶ FourLimbs x" by blast
  then have "Tetrapod x ⟶ FourLimbs x" by blast
  then have "Tetrapod x" by fact
  then have "FourLimbs x" by blast
  then show ?thesis by blast
qed

end
