theory question_4_8

imports Main

begin

typedecl entity

consts
  Ancathostega :: "entity ⇒ bool"
  Tetrapod :: "entity ⇒ bool"
  FourLimbs :: "entity ⇒ bool"

(* Explanation 1: Ancathostega is a type of tetrapod. *)
axiomatization where
  explanation_1: "∀x. Ancathostega x ⟶ Tetrapod x"

(* Explanation 2: All tetrapods are defined to have four limbs. *)
axiomatization where
  explanation_2: "∀x. Tetrapod x ⟶ FourLimbs x"

(* Explanation 3: If an entity is a tetrapod, then it has four limbs. *)
axiomatization where
  explanation_3: "∀x. Tetrapod x ⟶ FourLimbs x"

theorem hypothesis:
  assumes asm: "Ancathostega x"
  (* Hypothesis: Ancathostega have four limbs. *)
  shows "FourLimbs x"
proof -
  from asm have "Ancathostega x" by simp
  then have "Tetrapod x" using explanation_1 by blast
  then have "FourLimbs x" using explanation_2 by blast
  show ?thesis using asm `Tetrapod x` `FourLimbs x` by blast
qed

end
