theory question_63_6

imports Main

begin

typedecl entity
typedecl event

consts
  Rocks :: "entity ⇒ bool"
  SedimentaryRocks :: "entity ⇒ bool"
  Deposition :: "event ⇒ bool"
  FormedBy :: "entity ⇒ event ⇒ bool"
  Sandstone :: "entity ⇒ bool"
  Conditions :: "event ⇒ bool"
  FormedUnder :: "entity ⇒ event ⇒ bool"

(* Explanation 1: Sedimentary rocks are formed exclusively by deposition. *)
axiomatization where
  explanation_1: "∀x e. SedimentaryRocks x ∧ Deposition e ⟷ FormedBy x e"

(* Explanation 2: Sandstone is a specific type of sedimentary rock that is formed by deposition. *)
axiomatization where
  explanation_2: "∀x e. Sandstone x ∧ Deposition e ⟹ FormedBy x e ∧ SedimentaryRocks x"

(* Explanation 3: All sedimentary rocks formed by the same deposition event and under the same conditions are sandstone. *)
axiomatization where
  explanation_3: "∀x y e c. SedimentaryRocks x ∧ SedimentaryRocks y ∧ Deposition e ∧ Conditions c ∧ FormedBy x e ∧ FormedBy y e ∧ FormedUnder x c ∧ FormedUnder y c ⟹ x = y"

theorem hypothesis:
  assumes asm: "Rocks x ∧ Deposition e ∧ FormedBy x e"
  (* Hypothesis: Rocks formed by deposition are sandstone. *)
  shows "Sandstone x"
proof -
  have "SedimentaryRocks x" using explanation_1 asm by blast
  then have "Sandstone x" using explanation_2 asm by blast
  then show ?thesis by simp
qed

end
