theory question_13_0
imports Main

begin

typedecl entity
typedecl event

consts
  Weekend :: "entity ⇒ bool"
  Barbecue :: "entity ⇒ bool"
  Fish :: "entity ⇒ bool"
  BBQing :: "event ⇒ bool" (* event type added here *)
  Agent :: "event ⇒ entity ⇒ bool"
  Patient :: "event ⇒ entity ⇒ bool"
  Contains :: "entity ⇒ entity ⇒ bool"

(* Explanation: A weekend barbecue with some fish. *)
axiomatization where
  explanation_1: "∀x y e. Weekend x ∧ Barbecue y ∧ Fish e ∧ BBQing e ∧ Agent e x ∧ Patient e y ∧ Contains y e ⟶ Weekend x ∧ Barbecue y ∧ Fish e"

theorem hypothesis:
  (* Premise: Weekend barbecue with some fish. *)
  assumes asm: "Weekend x ∧ Barbecue y ∧ Fish e ∧ BBQing  e::event  ∧ Agent  e::event  x ∧ Patient  e::event  y ∧ Contains y  e::event "
  (* Hypothesis: Weekend barbecue with some fish. *)
  shows "∃x y e. Weekend x ∧ Barbecue y ∧ Fish e ∧ BBQing e ∧ Agent e x ∧ Patient e y ∧ Contains y e"
proof -
  from asm show ?thesis by blast
qed

end
