theory question_32_0

imports Main

begin

typedecl entity
typedecl event

consts
  LimeGreen :: "entity ⇒ bool"
  Pants :: "entity ⇒ bool"
  Shirt :: "entity ⇒ bool"
  Detail :: "entity ⇒ entity ⇒ bool"
  Wearing :: "entity ⇒ entity ⇒ bool"
  Man :: "entity ⇒ bool"
  Sign :: "entity ⇒ bool"
  WorkingOn :: "entity ⇒ entity ⇒ bool"

(* Explanation 1: The lime green is simply more detail to describe the pants and shirt the man is wearing. *)
axiomatization where
  explanation_1: "∀x y. LimeGreen x ∧ Pants y ∧ Shirt y ⟶ Detail x y ∧ Wearing x y"

theorem hypothesis:
  (* Premise: ∃x y z e. Man(x) ∧ LimeGreen(y) ∧ Pants(y) ∧ Shirt(z) ∧ Wearing(x, y) ∧ Wearing(x, z) ∧ Sign(e) ∧ WorkingOn(x, e) *)
  assumes asm: "Man x ∧ LimeGreen y ∧ Pants y ∧ Shirt z ∧ Wearing x y ∧ Wearing x z ∧ Sign e ∧ WorkingOn x e"
  (* Hypothesis: ∃x y z e. Man(x) ∧ Pants(y) ∧ Shirt(z) ∧ Wearing(x, y) ∧ Wearing(x, z) ∧ Sign(e) ∧ WorkingOn(x, e) *)
  shows "∃x y z e. Man x ∧ Pants y ∧ Shirt z ∧ Wearing x y ∧ Wearing x z ∧ Sign e ∧ WorkingOn x e"
proof -
  from asm show ?thesis by blast
qed

end
