theory question_36_10

imports Main

begin

typedecl entity
typedecl event

consts
  Busy :: "entity ⇒ bool"
  CityStreet :: "entity ⇒ bool"
  Street :: "entity ⇒ bool"
  Many :: "entity ⇒ bool"
  People :: "entity ⇒ bool"
  Has :: "entity ⇒ entity ⇒ bool"

theorem hypothesis:
  (* Hypothesis: The street has a lot of people. *)
  shows "∃x. Street x ∧ Many y ∧ People y ∧ Has x y"
proof -
  from asm have "Busy (cs::entity)" by (rule busy_city_street_implies_many_people[THEN iffD1])
  then have "Many (people_on_street::entity)" by (rule many_people_on_busy_street)
  then have "Street cs ∧ Many people_on_street ∧ People people_on_street ∧ Has cs people_on_street" by (rule implies_street_has_many_people)
  then show ?thesis by blast
qed

end
