theory question_47_4
imports Main

begin

typedecl entity
typedecl event

constant Agent :: "event ⇒ entity ⇒ bool"
constant Patient :: "event ⇒ entity ⇒ bool"
constant Theme :: "event ⇒ entity ⇒ bool"
constant Manner :: "event ⇒ bool"
constant Path :: "event ⇒ entity ⇒ bool"
constant Place :: "event ⇒ entity ⇒ bool"
constant Source :: "event ⇒ entity ⇒ bool"
constant Goal :: "event ⇒ entity ⇒ bool"
constant Run :: "event ⇒ bool"
constant Eat :: "event ⇒ bool"
constant Drink :: "event ⇒ bool"
constant Sing :: "event ⇒ bool"
constant Dance :: "event ⇒ bool"
constant Man :: "entity ⇒ bool"
constant Woman :: "entity ⇒ bool"
constant Dog :: "entity ⇒ bool"
constant Cat :: "entity ⇒ bool"
constant Bird :: "entity ⇒ bool"
constant Fish :: "entity ⇒ bool"
constant Table :: "entity ⇒ bool"
constant Chair :: "entity ⇒ bool"
constant Book :: "entity ⇒ bool"
constant Food :: "entity ⇒ bool"
constant Water :: "entity ⇒ bool"
constant Ground :: "entity ⇒ bool"
constant Tree :: "entity ⇒ bool"
constant Dress :: "entity ⇒ bool"
constant StarPrint :: "entity ⇒ bool"
constant Grill :: "entity ⇒ bool"
constant Near :: "entity ⇒ entity ⇒ bool"
constant Cooking :: "event ⇒ bool"

(* Premise: none *)

(* Hypothesis: ∃x y z e. Woman(x) ∧ Dress(y) ∧ StarPrint(y) ∧ Grill(z) ∧ Food(z) ∧ Near(x, z) ∧ Cooking(e) ∧ Agent(e, z) *)

theorem hypothesis:
  shows "∃x y z e. Woman x ∧ Dress y ∧ StarPrint y ∧ Grill z ∧ Food z ∧ Near x z ∧ Cooking e ∧ Agent e z"
proof -
  from {} obtain x y z e where "Woman x" "Dress y" "StarPrint y" "Grill z" "Food z" "Near x z" "Cooking e" "Agent e z" using classical by blast
  then show ?thesis by blast
qed

end
