theory question_51_4

imports Main

begin

typedecl entity
typedecl event

consts
  Man :: "entity ⇒ bool"
  GivingSpeech :: "entity ⇒ event ⇒ bool"
  PublicSpeaking :: "event ⇒ bool"

theorem hypothesis:
  (* Premise: For all x, none(x) *)
  assumes asm: "none x "
  (* Hypothesis: There exists x and e such that Man(x) and PublicSpeaking(e) and GivingSpeech(x, e) *)
  shows "∃x e. Man x  ∧ PublicSpeaking e  ∧ GivingSpeech x  e "
proof -
  from asm have "none x" by fact
  then have "¬∃x. Man x" by simp
  then have "∀x. ¬Man x" by blast
  from explanation_1 have "∀e. GivingSpeech x e ⟶ PublicSpeaking e" by blast
  then have "∃e. PublicSpeaking e ∧ GivingSpeech x e" by blast
qed

end
