theory question_55_0

imports Main

begin

typedecl entity
typedecl event

consts
  RaceCarDriver :: "entity ⇒ bool"
  Smiling :: "entity ⇒ entity ⇒ bool"
  OnStage :: "entity ⇒ entity ⇒ bool"
  SpokesModel :: "entity ⇒ bool"
  Female :: "entity ⇒ bool"
  NextTo :: "entity ⇒ entity ⇒ entity ⇒ entity ⇒ bool"
  White :: "entity ⇒ bool"
  Dress :: "entity ⇒ bool"
  Wearing :: "entity ⇒ entity ⇒ bool"
  WhiteAndBlue :: "entity ⇒ entity ⇒ bool"
  Boots :: "entity ⇒ bool"

theorem hypothesis:
  (* Premise: Two race car drivers smile on a stage next to a female spokes model wearing a white dress and white and blue boots. *)
  assumes asm: "RaceCarDriver x ∧ RaceCarDriver y ∧ Smiling x y ∧ OnStage x z ∧ SpokesModel w ∧ Female w ∧ NextTo x y z w ∧ White v ∧ Dress v ∧ Wearing w v ∧ WhiteAndBlue w z ∧ Boots z"
  (* Hypothesis: Two race car drivers are on stage. *)
  shows "∃x y. RaceCarDriver x ∧ RaceCarDriver y ∧ OnStage x y"
proof -
  from asm have "RaceCarDriver x" "RaceCarDriver y" "OnStage x z" "OnStage y z" by auto
  then show ?thesis using asm by blast
qed

end
