theory question_6_9

imports Main

begin

typedecl entity
typedecl event

consts
  Tumble :: "event ⇒ bool"
  Man :: "entity ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Watching :: "event ⇒ bool"
  Spectator :: "entity ⇒ bool"
  WatchedEvent :: "event ⇒ event ⇒ bool"
  Event :: "event ⇒ bool"
  Location :: "entity ⇒ bool"
  At :: "entity ⇒ entity ⇒ bool"
  AtEvent :: "event ⇒ entity ⇒ bool"

theorem hypothesis:
  (* Hypothesis: Spectators watch a man tumble. *)
  shows "∃x y e. Man x  ∧ Tumble e  ∧ Agent e  x  ∧ Spectator z  ∧ Watching e1  ∧ Agent e1  z  ∧ WatchedEvent e1  e "
proof -
  from asm have "Man x" "Tumble e" "Agent e x" "Spectator z" "Watching e1" "Agent e1 z" "AtEvent e1 l" "Location l" "At l u" "University_of_Michigan u" by auto
  then have "Event e1" using At Event by blast
  then have "WatchedEvent e1 e" using Tumble Event by blast
  then have "Man x" "Tumble e" "Agent e x" "Spectator z" "Watching e1" "Agent e1 z" "WatchedEvent e1 e" by blast
  then show ?thesis using asm by blast
qed

end
