theory question_61_0

imports Main

begin

typedecl entity
typedecl event

consts
  Woman :: "entity ⇒ bool"
  Seafood :: "entity ⇒ bool"
  Sunglasses :: "entity ⇒ bool"
  PoutingFace :: "entity ⇒ bool"
  Eating :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Patient :: "event ⇒ entity ⇒ bool"
  Has :: "entity ⇒ entity ⇒ bool"

(* Premise: A woman in sunglasses making a pouting face while eating seafood. *)
theorem hypothesis:
  assumes asm: "Woman x ∧ Sunglasses y ∧ PoutingFace z ∧ Eating e ∧ Agent e x ∧ Patient e y ∧ Has x z"
  (* Hypothesis: A woman is eating. *)
  shows "∃x e. Woman x ∧ Eating e ∧ Agent e x"
proof -
  from asm have "Woman x" "Eating e" "Agent e x" for x e by auto
  then show ?thesis using asm by blast
qed

end
