theory question_65_1
imports Main

begin

typedecl entity
typedecl event

consts
  OnePerson :: "entity ⇒ bool"
  Person :: "entity ⇒ bool"
  Alone :: "entity ⇒ bool"
  Lying :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Field :: "entity ⇒ bool"
  Large :: "entity ⇒ bool"
  Green :: "entity ⇒ bool"
  In :: "entity ⇒ entity ⇒ bool"
  Outdoors :: "entity ⇒ bool"

(* Explanation 1: ∀x. OnePerson(x) ⟶ Person(x) ∧ Alone(x) *)
axiomatization where
  explanation_1: "∀x. OnePerson x ⟶ Person x ∧ Alone x"

theorem hypothesis:
  (* Premise: ∃x. Person(x) ∧ Lying(e) ∧ Agent(e, x) ∧ Large(f) ∧ Green(f) ∧ Field(f) ∧ In(x, f) *)
  assumes asm: "Person x ∧ Lying e ∧ Agent e x ∧ Large f ∧ Green f ∧ Field f ∧ In x f"
  (* Hypothesis: ∃x. Person(x) ∧ Alone(x) ∧ Field(x) ∧ Outdoors(x) *)
  shows "∃x. Person x ∧ Alone x ∧ Field x ∧ Outdoors x"
proof -
  from asm have "OnePerson x" using explanation_1 by blast
  then have "Person x ∧ Alone x" using explanation_1 by blast
  moreover have "Field x ∧ Outdoors x"
    by (rule field_outdoors[OF _ Large Green Field In])
  ultimately show "∃x. Person x ∧ Alone x ∧ Field x ∧ Outdoors x" by blast
qed

end
