theory question_69_0
imports Main

begin

typedecl entity
typedecl event

consts
  Girl :: "entity ⇒ bool"
  Sacks :: "entity ⇒ bool"
  Carries :: "entity ⇒ entity ⇒ bool"
  Large :: "entity ⇒ bool"
  Foliage :: "entity ⇒ bool"
  Across :: "entity ⇒ entity ⇒ bool"
  Carrying :: "event ⇒ entity ⇒ entity ⇒ bool"

(* Explanation 1: "Girl carrying sacks" rephrases "girl carries sacks" *)
axiomatization where
  explanation_1: "∀x y. Girl x ∧ Sacks y ⟶ Carries x y"

theorem hypothesis:
  (* Premise: A girl carries large sacks across a backdrop of foliage. *)
  assumes asm: "Girl x ∧ Large y ∧ Sacks y ∧ Carrying e x y ∧ Across x z ∧ Foliage z"
  (* Hypothesis: A girl carrying sacks. *)
  shows "∃x y e. Girl x ∧ Sacks y ∧ Carrying e x y"
proof -
  from asm have "Girl x ∧ Sacks y ∧ Carrying e x y" by blast
  then show ?thesis by blast
qed

end
