theory question_7_3
imports Main

begin

typedecl entity
typedecl event

consts
  Outside :: "entity ⇒ bool"
  Ground :: "entity ⇒ bool"
  Raining :: "event ⇒ bool"
  Wet :: "entity ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Woman :: "entity ⇒ bool"
  Guitar :: "entity ⇒ bool"
  Tree :: "entity ⇒ bool"
  Sitting :: "event ⇒ bool"
  Playing :: "event ⇒ bool"
  Under :: "entity ⇒ entity ⇒ bool"
  Patient :: "event ⇒ entity ⇒ bool"
  Girl :: "entity ⇒ bool"
  Jumps :: "event ⇒ bool"

(* Premise: none *)

(* Hypothesis: ∃x e. Girl(x) ∧ Jumps(e) ∧ Agent(e, x) *)

axiomatization where
  hypothesis: "∃x e. Girl x ∧ Jumps e ∧ Agent e x"

theorem hypothesis:
  assumes asm: "True"
  shows "∃x e. Girl x ∧ Jumps e ∧ Agent e x"
proof -
  from asm obtain x e where g: "Girl x" and j: "Jumps e" and a: "Agent e x" by (rule hypothesis)
  then show ?thesis using g j a by blast
qed

end
