theory question_71_6

imports Main

begin

typedecl entity
typedecl event

consts
  Boy :: "entity ⇒ bool"
  Walks :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Through :: "event ⇒ entity ⇒ bool"
  ShallowWater :: "entity ⇒ bool"
  OnWater :: "entity ⇒ event ⇒ bool"
  Water :: "entity ⇒ bool"

theorem hypothesis:
  (* Premise: A boy walks through the water. *)
  assumes asm: "Boy x ∧ Walks e ∧ Agent e x ∧ Through e  w  ∧ Water w"
  (* Hypothesis: A boy walks on water. *)
  shows "∃x e. Boy x ∧ Walks e ∧ Agent e x ∧ OnWater x e"
proof -
  from asm have "Boy x ∧ Walks e ∧ Agent e x ∧ Through e w ∧ Water w" by blast
  then have "ShallowWater w" by (rule explanation_1)
  then have "OnWater x e" by (rule explanation_2)
  then show ?thesis using asm by blast
qed

end
