theory question_76_0
imports Main

begin

typedecl entity
typedecl event

consts
  Boys :: "entity ⇒ bool"
  Bikes :: "entity ⇒ bool"
  Riding :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Patient :: "event ⇒ entity ⇒ bool"
  Wearing :: "event ⇒ entity ⇒ entity ⇒ bool"
  WinterHat :: "entity ⇒ bool"
  Coat :: "entity ⇒ bool"
  ColorfulWinterHat :: "entity ⇒ bool"
  DarkCoat :: "entity ⇒ bool"
  Smiling :: "event ⇒ bool"
  Target :: "event ⇒ entity ⇒ bool"

(* Explanation 1: Two boys while wearing winter hats and coats are riding a bike *)
axiomatization where
  explanation_1: "∃x y z e. Boys x ∧ x = y ∧ Bikes z ∧ Riding e ∧ Agent e x ∧ Patient e z ∧ Wearing e x WinterHat ∧ Wearing e x Coat"

theorem hypothesis:
  (* Premise: Two boys wearing colorful winter hats and dark coats are riding bikes and smiling at each other. *)
  assumes asm: "Boys x ∧ x = y ∧ Bikes z ∧ Riding e1 ∧ Agent e1 x ∧ Patient e1 z ∧ Wearing e2 x ColorfulWinterHat ∧ Wearing e2 x DarkCoat ∧ Smiling e2 ∧ Agent e2 x ∧ Target e2 y"
  (* Hypothesis: Two boys are riding bikes. *)
  shows "∃x y e. Boys x ∧ x = y ∧ Bikes y ∧ Riding e ∧ Agent e x ∧ Patient e y"
proof -
  from asm have "Boys x ∧ x = y ∧ Bikes z ∧ Riding e1 ∧ Agent e1 x ∧ Patient e1 z" by blast
  then show ?thesis using asm by blast
qed

end
