theory question_87_3
imports Main

begin

typedecl entity
typedecl event

consts
  SmilingYoungGirl :: "entity ⇒ bool"
  BlondHair :: "entity ⇒ bool"
  BlueEyes :: "entity ⇒ bool"
  PinkShirt :: "entity ⇒ bool"
  Flower :: "entity ⇒ bool"
  Yellow :: "entity ⇒ bool"
  Object :: "entity ⇒ bool"
  Viewer :: "entity ⇒ bool"
  Outside :: "entity ⇒ bool"
  Agent :: "entity ⇒ entity ⇒ bool"
  Towards :: "entity ⇒ entity ⇒ bool"

(* Explanation: A smiling young girl with blond-hair, blue eyes, and a pink shirt, is holding a yellow flower towards the viewer outside. *)
axiomatization where
  explanation_1: "∀x y. SmilingYoungGirl x ∧ BlondHair x ∧ BlueEyes x ∧ PinkShirt x ∧ Object y ∧ Flower y ∧ Yellow y ∧ Agent x y ∧ Towards x Viewer ∧ Outside Viewer ⟶ ∃x. SmilingYoungGirl x ∧ BlondHair x"

theorem hypothesis:
  (* Premise: A smiling young girl with blond-hair, blue eyes, and a pink shirt, is holding a yellow flower towards the viewer outside. *)
  assumes asm: "SmilingYoungGirl x ∧ BlondHair x ∧ BlueEyes x ∧ PinkShirt x ∧ Object y ∧ Flower y ∧ Yellow y ∧ Agent x y ∧ Towards x Viewer ∧ Outside Viewer"
  (* Hypothesis: A smiling young girl with blond-hair. *)
  shows "∃x. SmilingYoungGirl x ∧ BlondHair x"
proof -
  from asm have "SmilingYoungGirl x ∧ BlondHair x" by blast
  then show ?thesis by blast
qed

end
