theory question_9_0

imports Main

begin

typedecl entity
typedecl event

consts
  Sprayed :: "event ⇒ entity ⇒ entity ⇒ bool"
  HosedDown :: "event ⇒ bool"
  Children :: "entity ⇒ bool"
  Grass :: "entity ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Theme :: "event ⇒ entity ⇒ bool"
  Location :: "entity ⇒ entity ⇒ bool"

theorem hypothesis:
  (* Hypothesis: Children are getting hosed down on the grass. *)
  shows "∃x y z e. Children x ∧ Grass y ∧ HosedDown e ∧ Agent e z ∧ Theme e x ∧ Location x y"
proof -
  from asm have "Sprayed e children_1 grass" for some children_1 by (rule exI[where x="children_1"])
  then have "HosedDown e" using explanation_1 by blast
  from asm have "Sprayed e children_2 grass" for some children_2 by (rule exI[where x="children_2"])
  then have "Children children_2" by (rule explanation_1)
  show ?thesis using asm HosedDown explanation_1 by blast
qed

end
