theory question_96_6

imports Main

begin

typedecl entity

consts
  Child :: "entity ⇒ bool"
  Adult :: "entity ⇒ bool"
  Group :: "entity ⇒ bool"
  Person :: "entity ⇒ bool"
  Member :: "entity ⇒ entity ⇒ bool"
  Swimming :: "entity ⇒ bool"
  LargePool :: "entity ⇒ bool"
  RedStaircase :: "entity ⇒ bool"

theorem hypothesis:
  (* Premise: Children and adults swim in large pool with red staircase. *)
  assumes asm: "Group g ∧ Person x ∧ Member x g ∧  Swimming x ∧ LargePool x ∧ RedStaircase x "
  (* Hypothesis: A group of people are swimming. *)
  shows "∃g. Group g ∧ ∀x. Person x ∧ Member x g ∧ Swimming x"
proof -
  from asm have "Person x" "Swimming x" for x by auto
  then have "∃g. Group g ∧ Person x ∧ Member x g ∧ Swimming x" using asm by blast
  then show ?thesis by blast
qed

end
