theory question_11_3

imports Main

begin

typedecl entity
typedecl event

consts
  Fibers :: "entity ⇒ bool"
  Shorter :: "entity ⇒ bool"
  Contraction :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Result :: "event ⇒ entity ⇒ bool"
  Injury :: "event ⇒ bool"
  Stretch :: "event ⇒ bool"
  Muscle :: "entity ⇒ bool"

theorem hypothesis:
  assumes asm: "Muscle x ∧ Fibers y ∧ Shorter y ∧ Stretch e ∧ Agent e x"
  (* Hypothesis: When the muscle is stretched while fibers are shorter, injury happens. *)
  shows "Injury e"
proof -
  from asm have "Muscle x ∧ Fibers y ∧ Shorter y ∧ Contraction e' ∧ Agent e' x" using explanation_1 by blast
  then have "Shorter y ∧ Stretch e ∧ Agent e x" using asm by simp
  then show "Injury e" using explanation_2 by blast
qed

end
