theory question_17_6
imports Main

begin

typedecl entity
typedecl event

consts
  Omnivores :: "entity ⇒ bool"
  Consumer :: "entity ⇒ bool"
  Feed :: "entity ⇒ entity ⇒ bool"
  Plant :: "entity ⇒ bool"
  Animal :: "entity ⇒ bool"
  TrophicLevel :: "event ⇒ int ⇒ bool"

theorem hypothesis:
  assumes asm: "Omnivores x"
  (* Hypothesis: Omnivores can feed at more than one trophic level. *)
  shows "∃e. Feed x e ∧ TrophicLevel e  >=1 "
proof -
  from asm have "Consumer x" using explanation_1 by blast
  then obtain e where e: "Feed x e" by auto
  then have "TrophicLevel e  >=1" using explanation_2 by blast
  then have conclusion: "Feed x e ∧ TrophicLevel e  >=1" using e by simp
  show ?thesis using asm conclusion by blast
qed

end
