theory question_28_1

imports Main

begin

typedecl entity

consts
  Animals :: "entity ⇒ bool"
  Heterotrophs :: "entity ⇒ bool"
  NutrientsNeeded :: "entity ⇒ bool"

(* Explanation 1: All animals are heterotrophs. *)
axiomatization where
  explanation_1: "∀x. Animals x ⟶ Heterotrophs x"

(* Hypothesis: All animals need nutrients. *)
theorem hypothesis:
  assumes asm: "Animals x"
  shows "NutrientsNeeded x"
proof -
  from asm have "Animals x" by simp
  then have "Heterotrophs x" using explanation_1 by blast
  then have "NutrientsNeeded x" using explanation_2 by blast
  then show ?thesis using asm `NutrientsNeeded x` by blast
qed

end
