theory question_3_5
```
imports Main

begin

typedecl entity
typedecl event

consts
  ElectricFan :: "entity ⇒ bool"
  Vanes :: "entity ⇒ bool"
  Room :: "entity ⇒ bool"
  Rotating :: "event ⇒ bool"
  Move :: "event ⇒ bool"
  Air :: "entity ⇒ bool"
  Help :: "event ⇒ bool"
  LessShortOfBreath :: "entity ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Patient :: "event ⇒ entity ⇒ bool"

(* Explanation 1: The rotation of the vanes in an electric fan causes air to move in a room. *)
axiomatization where
  explanation_1: "∀x y z e1 e2. ElectricFan x ∧ Vanes y ∧ Room z ⟶ (Rotating e1 ∧ Agent e1 y ∧ Patient e1 x) ⟶ (Move e2 ∧ Agent e2 Air ∧ Patient e2 z)"

(* Explanation 2: An electric fan is an entity that directly causes air movement when its vanes rotate. *)
axiomatization where
  explanation_2: "∀x y e. ElectricFan x ∧ Vanes y ∧ Rotating e ⟶ (∃z. Move z ∧ Agent z Air ∧ Patient z x)"

(* Explanation 3: The movement of air in a room, caused by the rotation of an electric fan, helps people feel less short of breath. *)
axiomatization where
  explanation_3: "∀x y z e1 e2 e3. ElectricFan x ∧ Vanes y ∧ Room z ∧ Rotating e1 ∧ Agent e1 y ∧ Patient e1 x ⟶ (Move e2 ∧ Agent e2 Air ∧ Patient e2 z) ⟶ (∃e3. Help e3 ∧ Agent e3 x ∧ Patient e3 w ∧ LessShortOfBreath w)"
