theory question_31_4

imports Main

begin

typedecl entity
typedecl event

consts
  Object :: "entity ⇒ bool"
  Shape :: "entity ⇒ bool"
  Change :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Patient :: "event ⇒ entity ⇒ bool"
  Removing :: "event ⇒ bool"

theorem hypothesis:
  assumes asm: "Object x ∧ Shape y ∧ Change e ∧ Agent e x ∧ Patient e y"
  (* Hypothesis: One way an object's shape can be changed is by removing material. *)
  shows "Removing e"
proof -
  have "Change e ∧ Agent e x ∧ Patient e y ∧ Removing (e::event)"
    using assms explanation_1 by blast
  then show "Removing e" by simp
qed

end
