theory question_44_1
```
imports Main

begin

typedecl entity
typedecl event

consts
  Vanes :: "entity ⇒ bool"
  ElectricFan :: "entity ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Rotating :: "event ⇒ bool"
  Patient :: "event ⇒ entity ⇒ bool"
  Causes :: "event ⇒ bool"
  Movement :: "entity ⇒ bool"
  ComposedOf :: "entity ⇒ entity ⇒ bool"
  Nitrogen :: "entity ⇒ bool"
  Oxygen :: "entity ⇒ bool"
  PartOf :: "entity ⇒ entity ⇒ bool"

(* Explanation 1: The rotation of the vanes in an electric fan causes air movement. *)
axiomatization where
  explanation_1: "∀e1 e2 e3. Vanes e1 ∧ ElectricFan e2 ∧ Agent e3 e1 ∧ Rotating e3 ∧ Patient e3 e2 ⟶ Causes e3 ∧ Movement e1 ∧ Patient e1 e2"

(* Explanation 2: Air is primarily composed of nitrogen and oxygen, and they are part of the air entity. *)
axiomatization where
  explanation_2: "∀x y z. Air x ⟶ (ComposedOf x y ∧ Nitrogen y) ∧ (ComposedOf x z ∧ Oxygen z)"

(* Explanation 3: When the air moves due to the rotation of the vanes in an electric fan, the nitrogen and oxygen that make up the air also move with it. *)
axiomatization where
  explanation_3: "∀e1 e2 x y z. Air x ∧ Nitrogen y ∧ Oxygen z ∧ PartOf y x ∧ PartOf z x ∧ Agent e1 e2 ∧ Rotating e1 ∧ Patient e1 x ⟶ Movement e1 ∧ Patient e1 x 