theory question_47_4

imports Main

begin

typedecl entity
typedecl event

consts
  Genes :: "entity ⇒ bool"
  LocatedOnSameChromosome :: "entity ⇒ entity ⇒ bool"
  InheritedTogether :: "event ⇒ entity ⇒ entity ⇒ bool"

theorem hypothesis:
  assumes asm: "Genes x ∧ Genes y ∧ LocatedOnSameChromosome x y"
  (* Hypothesis: Genes are inherited together if they are located on the same chromosome. *)
  shows "∃e. InheritedTogether e x y"
proof -
  from asm have "Genes x ∧ Genes y ∧ LocatedOnSameChromosome x y" by simp
  then have "InheritedTogether e x y" for some e using explanation_2 by blast
  then show "∃e. InheritedTogether e x y" by simp
qed

end
