theory question_60_3
imports Main

begin

typedecl entity

consts
  Animals :: "entity ⇒ bool"
  Food :: "entity ⇒ bool"
  Require :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Patient :: "event ⇒ entity ⇒ bool"
  Move :: "event ⇒ bool"

(* Explanation: Animals require food to move. *)
axiomatization where
  explanation: "∀x y e. Animals x ∧ Food y ∧ Require e ∧ Agent e x ∧ Patient e y ⟶ Move e ∧ Agent e x"

theorem hypothesis:
  assumes asm: "Animals x ∧ Food y ∧ Require e ∧ Agent e x ∧ Patient e y"
  (* Hypothesis: Animals require food to move. *)
  shows "Move e ∧ Agent e x"
proof -
  from asm have "Move e ∧ Agent e x" using explanation by blast
  then show ?thesis by simp
qed

end
