theory question_63_7

imports Main

begin

typedecl entity
typedecl event

consts
  SedimentaryRocks :: "entity ⇒ bool"
  Includes :: "entity ⇒ entity ⇒ bool"
  Rocks :: "entity ⇒ bool"
  FormedByDeposition :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Sandstone :: "entity ⇒ bool"

theorem hypothesis:
  assumes asm: "Rocks x ∧ FormedByDeposition y ∧ Agent y x"
  (* Hypothesis: Rocks formed by deposition are sandstone. *)
  shows "Sandstone x"
proof -
  from asm have "Rocks x" by simp
  then have "SedimentaryRocks x" using explanation_1 by blast
  then have "Sandstone x" using explanation_3 by blast
  then show ?thesis using asm by simp
qed

end
