theory question_66_0

imports Main

begin

typedecl entity
typedecl event

consts
  Plants :: "entity ⇒ bool"
  SeedDispersal :: "entity ⇒ bool"
  Reproduction :: "entity ⇒ bool"
  Require :: "entity ⇒ entity ⇒ bool"
  Animals :: "entity ⇒ bool"

(* Explanation: Plants require animals for reproduction. *)
axiomatization where
  explanation: "∀x y. Plants x ∧ Reproduction y ⟶ Require x y ∧ Agent y Animals"

theorem hypothesis:
  assumes asm: "Plants x ∧ Reproduction y"
  (* Hypothesis: Plants require animals for reproduction. *)
  shows "Require x y ∧ Agent y Animals"
proof -
  from asm have "Require x y" using explanation by blast
  then have "Agent y Animals" using explanation by blast
  show ?thesis using asm `Require x y` `Agent y Animals` by blast
qed

end
