theory question_77_1

imports Main

begin

typedecl entity

consts
  Mollusks :: "entity ⇒ bool"
  Mussels :: "entity ⇒ bool"
  Shell :: "entity ⇒ bool"
  BivalveMollusk :: "entity ⇒ bool"

(* Explanation 1: Most mollusks, including mussels, have shells. *)
axiomatization where
  explanation_1: "∀x. Mollusks x ∧ Mussels x ⟶ Shell x"

(* Explanation 2: Mussels are a type of bivalve mollusk. *)
axiomatization where
  explanation_2: "∀x. Mussels x ⟶ BivalveMollusk x"

theorem hypothesis:
  assumes asm: "Mussels x"
  (* Hypothesis: Mussels have a shell. *)
  shows "Shell x"
proof -
  from asm have "Mollusks x" using explanation_2 by simp
  then have "Shell x" using explanation_1 by blast
qed

end
