theory question_83_9
imports Main

begin

typedecl entity
typedecl event

consts
  Computers :: "entity ⇒ bool"
  Runs :: "event ⇒ entity ⇒ bool"
  Flowing :: "entity ⇒ event ⇒ bool"
  Working :: "event ⇒ bool"
  ElectricalCircuit :: "entity ⇒ event ⇒ bool"

theorem hypothesis:
  assumes asm: "Computers x ∧ Working  e::entity  ∧ ElectricalCircuit x e"
  (* Hypothesis: Computers run when electrical circuit is working properly. *)
  shows "Runs e x"
proof -
  from asm have "Computers x ∧ Working e ∧ ElectricalCircuit x e" by simp
  then have "Flowing (the (entity_op x)) e" using explanation_1 by blast
  then have "Runs e x" using explanation_3 by blast
  show ?thesis using asm `Flowing (the (entity_op x)) e` by blast
qed

end
