theory question_84_5
imports Main

begin

typedecl entity
typedecl event

consts
  Mammals :: "entity ⇒ bool"
  Birds :: "entity ⇒ bool"
  GenerateHeat :: "event ⇒ entity ⇒ bool"
  HighEnergyRequirement :: "entity ⇒ entity ⇒ bool"

theorem hypothesis:
  assumes asm: "Bird x"
  (* Hypothesis: If an x is a bird, then there exist y and z such that y is a high energy requirement and z generates heat for x. *)
  shows "∃y z e. HighEnergyRequirement y x ∧ GenerateHeat e z x"
proof -
  from asm have "HighEnergyRequirement (?x) x" using explanation_2 by blast
  then obtain e where e: "GenerateHeat e (?z) x" using explanation_3 by blast
  have conclusion: "HighEnergyRequirement (?x) x ∧ GenerateHeat e (?z) x" using e by simp
  show ?thesis using asm conclusion by blast
qed

end
