theory question_88_3
imports Main

begin

typedecl entity
typedecl event

consts
  Bulb :: "entity ⇒ bool"
  Uses :: "entity ⇒ event ⇒ bool"
  ElectricalEnergy :: "event ⇒ bool"
  Produces :: "entity ⇒ event ⇒ bool"
  Rays :: "entity ⇒ bool"

theorem hypothesis:
  assumes asm: "Uses b e ∧ ElectricalEnergy e ∧ Produces b e ∧ Rays r"
  (* Hypothesis: A bulb uses electrical energy to produce rays. *)
  shows "∃b e r. Bulb b ∧ Uses b e ∧ ElectricalEnergy e ∧ Produces b e ∧ Rays r"
proof -
  from asm have "Uses b e ∧ ElectricalEnergy e ∧ Produces b e ∧ Rays r" by simp
  then have "Bulb b ∧ Uses b e ∧ ElectricalEnergy e ∧ Produces b e ∧ Rays r" using explanation_1 by blast
  then show ?thesis by blast
qed

end
