theory question_23_2

imports Main

begin

typedecl entity
typedecl event

consts
  Hurricanes :: "entity ⇒ bool"
  Tornadoes :: "entity ⇒ bool"
  Entity :: "entity ⇒ bool"
  Has :: "entity ⇒ entity ⇒ bool"
  HighWinds :: "entity ⇒ bool"

theorem hypothesis:
  assumes asm: "Hurricanes x ∨ Tornadoes y"
  (* Hypothesis: Both hurricanes and tornadoes always have high winds. *)
  shows "HighWinds x ∧ HighWinds y"
proof -
  from asm have "Hurricanes x ⟶ HighWinds x" using explanation_1 by blast
  then have "HighWinds x" if "Hurricanes x" using asm by simp
  from asm have "Tornadoes y ⟶ HighWinds y" using explanation_2 by blast
  then have "HighWinds y" if "Tornadoes y" using asm by simp
  show ?thesis using asm explanation_1 explanation_2 by blast
qed

end
