theory question_40_6

imports Main

begin

typedecl entity
typedecl event

consts
  Weathering :: "event ⇒ bool"
  Boulder :: "entity ⇒ bool"
  LargeRock :: "entity ⇒ bool"
  BreakingDown :: "event ⇒ entity ⇒ entity ⇒ bool"
  CracksForming :: "event ⇒ entity ⇒ bool"

(* Hypothesis: Cracks forming in a boulder can be caused by weathering. *)
theorem hypothesis:
  assumes asm: "Boulder x ∧ CracksForming e x"
  shows "Weathering e"
proof -
  from asm have "Boulder x" by simp
  then have "BreakingDown e x y" for y using explanation_1 by blast
  then have "CracksForming e x" by (simp add: BreakingDown_def)
  then have "Weathering e" using explanation_1 by blast
  then show ?thesis by simp
qed

end
