theory question_81_5

imports Main

begin

typedecl entity

consts
  Soil :: "entity ⇒ bool"
  Nonliving :: "entity ⇒ bool"
  Part :: "entity ⇒ entity ⇒ bool"
  Forest :: "entity ⇒ bool"
  Agent :: "entity ⇒ entity ⇒ bool"

theorem hypothesis:
  assumes asm: "Soil x"
  (* Hypothesis: Soil is a nonliving part of a forest. *)
  shows "∃y z. Nonliving y ∧ Part z ∧ Forest y ∧ Agent x z"
proof -
  from asm have "Soil x" by simp
  then have "∃y. Nonliving y ∧ Part x y" using explanation_1 by blast
  then obtain y where ny: "Nonliving y" and py: "Part x y" by auto
  have "Forest x" using py explanation_1 by blast
  have "Agent x y" using py explanation_1 by blast
  show ?thesis using ny ny py by blast
qed

end
