theory question_89_2
```
imports Main

begin

typedecl entity
typedecl event

consts
  Pulley :: "entity ⇒ bool"
  SimpleMachine :: "entity ⇒ bool"
  Lift :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Patient :: "event ⇒ entity ⇒ bool"
  Object :: "entity ⇒ bool"
  Moving :: "event ⇒ bool"
  Up :: "entity ⇒ bool"
  HelpsMove :: "event ⇒ bool"
  Uses :: "entity ⇒ entity ⇒ bool"
  Flag :: "entity ⇒ bool"
  Flagpole :: "entity ⇒ bool"

(* Explanation 1: A pulley is a kind of simple machine that is used to lift objects. *)
axiomatization where
  explanation_1: "∀x. Pulley x ∧ SimpleMachine x ⟶ (∃e y. Lift e ∧ Agent e x ∧ Patient e y ∧ Object y)"

(* Explanation 2: Lifting an object means moving it up. *)
axiomatization where
  explanation_2: "∀x y e. Lift x ∧ Agent e x ∧ Patient e y ⟶ (∃e1. Moving e1 ∧ Agent e1 x ∧ Patient e1 y ∧ Up e1)"

(* Explanation 3: A pulley helps move up the objects it lifts. *)
axiomatization where
  explanation_3: "∀x y z e. Pulley x ∧ SimpleMachine x ∧ Object y ∧ Up z 