theory question_94_7
imports Main

begin

typedecl entity
typedecl event

consts
  Residents :: "entity ⇒ bool"
  He :: "entity ⇒ bool"
  Experiences :: "event ⇒ bool"
  Winter :: "event ⇒ bool"
  August :: "event ⇒ bool"
  Agent :: "event ⇒ entity ⇒ bool"
  Lives :: "entity ⇒ bool"
  SouthernHemisphere :: "entity ⇒ bool"

theorem hypothesis:
  (* Premise: Andy lives in the southern hemisphere. *)
  assumes asm: "Residents x ∧ Lives x ∧ SouthernHemisphere"
  (* Hypothesis: He experiences winter in August. *)
  shows "∃x e. He x  ∧ Experiences e  ∧ Winter e  ∧ August e  ∧ Agent e  x "
proof -
  from asm have "SouthernHemisphere x" by simp
  then have "∃e. Experiences e ∧ Winter e ∧ August e ∧ Agent e x"
    using explanation_1 by blast
  then show ?thesis by blast
qed

end
