theory question_94_8

imports Main

begin

typedecl entity
typedecl event

consts
  Residents :: "entity ⇒ bool"
  SouthernHemisphere :: "entity ⇒ bool"
  Andy :: "entity ⇒ bool"
  Winter :: "event ⇒ bool"
  August :: "event ⇒ bool"
  Has :: "event ⇒ bool"
  Experiences :: "event ⇒ bool"

theorem hypothesis:
  (* Premise: andy lives in the southern hemisphere. *)
  assumes asm: "Andy x ∧ Residents x ∧ SouthernHemisphere x"
  (* Hypothesis: He experiences winter in August. *)
  shows "∃x e. He x ∧ Experiences e ∧ Winter e ∧ August e ∧ Agent e x"
proof -
  from asm have "Residents x" by simp
  then have "SouthernHemisphere x ⟶ (∃e. Experiences e ∧ Winter e ∧ August e ∧ Agent e x)" using explanation_3 by blast
  then show ?thesis using asm by blast
qed

end
