theory question_97_9

imports Main

begin

typedecl entity
typedecl event

consts
  Classifying :: "entity ⇒ bool"
  Galaxies :: "entity ⇒ bool"
  Shape :: "entity ⇒ bool"
  Method :: "event ⇒ bool"
  Patient :: "event ⇒ entity ⇒ bool"

(* Explanation 1: Classifying galaxies by shape is a method of classifying galaxies. *)
axiomatization where
  explanation_1: "∀x y. Classifying x ∧ Galaxies y ∧ Shape x ⟶ Method e ∧ Patient e x ∧ Patient e y"

theorem hypothesis:
  (* Hypothesis: Shape is used to classify galaxies. *)
  shows "∃x y. Shape x ∧ Galaxies y ∧ Classify e ∧ Agent e x ∧ Patient e y"
proof -
  obtain x y e where "Shape x" "Galaxies y" "Classifying e" "Agent e x" "Patient e x" "Patient e y"
    using explanation_1 by blast
  then show ?thesis by simp
qed

end
